<?xml version="1.0" encoding="iso-8859-1"?>
<!-- Todo:
  
     [xsl:include] Using a hardcoded path is B A D. Maybe the XML document
     should contain the correct working directory. How else might we determine
     this at runtime?

  -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <!-- [ ! ] --><xsl:include href="common.xsl"/>

  <xsl:template match="/">
    <HTML>
      <xsl:variable name="op" select="dialog/head/operation"/>
      <xsl:variable name="status" select="dialog/head/operation@status"/>
      <xsl:variable name="cfg" select="dialog/head/vm/cfg"/>
      <xsl:variable name="displayName" select="dialog/head/vm/cfg@displayName"/>
      <xsl:variable name="idxKey" select="dialog/head/multipartKey[@name='idx']"/>
      <xsl:variable name="btnKey" select="dialog/head/multipartKey[@name='btn']"/>
      <LINK rel="stylesheet" href="{$common}style.css" type="text/css"/>
      <HEAD>
        <TITLE><xsl:value-of select="dialog/head/title"/> [ <xsl:value-of select="$displayName"/> ]</TITLE>
        
        <xsl:choose>
          <xsl:when test="number(/dialog/head/vm/input[@name='error-id']@value)=-16">
            <xsl:variable name="qid" select="number(/dialog/head/vm/input[@name='question-id']@value)"/>
            <xsl:variable name="mpersand">%26</xsl:variable>
            <SCRIPT>
              function cleanup( ) {
                window.opener.location.reload( );
                window.close( );
              }
              <xsl:if test="number($qid) != -1">
                window.location.href='answer?status=pending' +
                                      unescape('<xsl:value-of select="$mpersand"/>') +
                                      'vm=<xsl:value-of select="$cfg"/>' +
                                      unescape('<xsl:value-of select="$mpersand"/>') +
                                      'question-id=<xsl:value-of select="$qid"/>';
              </xsl:if>
            </SCRIPT>
          </xsl:when>
          <xsl:when test="string(dialog@type) = 'notice'">
            <SCRIPT>
              function cleanup( ) {
                window.opener.location.reload( );
                window.close( );
              }
              function doCB( ) { window.opener.<xsl:value-of select="$op"/>_CB( self ); }
              window.focus( );
            </SCRIPT>
          </xsl:when>
          <xsl:when test="string(dialog@type) = 'prompt' and string($status) = 'pending'">
            <SCRIPT src="{$common}answer-dlg.js"></SCRIPT>
          </xsl:when>
          <xsl:otherwise>
            <SCRIPT>
              function cleanup( ) {
                window.opener.location.reload( );
                window.close( );
              }
              window.focus( );
            </SCRIPT>
          </xsl:otherwise>
        </xsl:choose>
      </HEAD>

      <FRAMESET rows="*,41" frameborder="no" border="0" onload="doCB();">
        <xsl:variable name="question-id" select="dialog/body/args[@name='QUESTION']/input[@name='question-id']@value"/>
        <FRAME name="idx" src="answer-idx?status={$status}{$ampersand}vm={$cfg}{$ampersand}question-id={$question-id}{$ampersand}part=idx{$ampersand}multipart-key={$idxKey}"/>
        <FRAME name="btn" src="answer-btn?status={$status}{$ampersand}vm={$cfg}{$ampersand}question-id={$question-id}{$ampersand}part=btn{$ampersand}multipart-key={$btnKey}" scrolling="no"/>
      </FRAMESET>
    </HTML>
  </xsl:template>
</xsl:stylesheet>

