<?xml version="1.0" encoding="iso-8859-1"?>
<!-- Todo:
  
     [xsl:include] Using a hardcoded path is B A D. Maybe the XML document
     should contain the correct working directory. How else might we determine
     this at runtime?

  -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <!-- [ ! ] --><xsl:include href="common.xsl"/>

  <xsl:template match="/">
    <HTML>
      <HEAD>
        <TITLE><xsl:value-of select="dialog/head/title"/></TITLE>
        <LINK rel="stylesheet" href="{$common}style.css" type="text/css"/>
        <xsl:choose>
          <xsl:when test="string(dialog@type) = 'notice'">
            <xsl:variable name="operation" select="dialog/head/operation"/>
            <xsl:variable name="cfg" select="dialog/head/vm/cfg"/>
            <xsl:choose>
              <xsl:when test="string(dialog/head/operation@status) = 'pending'">
                <SCRIPT>
                  function doCB( ) { window.opener.<xsl:value-of select="$operation"/>( window.opener.getVmIndex( '<xsl:value-of select="$cfg"/>' ), 'confirmed', true ); }
                  window.onload = window.setTimeout( "doCB( )", 1000 );
                  window.focus( );
                </SCRIPT>
              </xsl:when>
              <xsl:otherwise>
                <SCRIPT>
                  function doCB( ) { window.opener.<xsl:value-of select="$operation"/>_CB( self ); }
                  window.onload = window.setTimeout( "doCB( )", 2000 );
                  window.focus( );
                </SCRIPT>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <xsl:otherwise>
            <SCRIPT>
              window.onload = window.focus( );
            </SCRIPT>
          </xsl:otherwise>
        </xsl:choose>
      </HEAD>

      <BODY background="{$imx}FFFFE6.png" bgcolor="#FFFFE6">

        <TABLE border="0" cellpadding="3" cellspacing="2" width="100%">
          <TR>
            <xsl:variable name="icon">
              <xsl:choose>
                <xsl:when test="string(dialog@type) = 'notice'">info.gif</xsl:when>
                <xsl:when test="string(dialog@type) = 'alert'">error.gif</xsl:when>
                <xsl:when test="string(dialog@type) = 'prompt'">question.gif</xsl:when>
                <xsl:otherwise>info.gif</xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
            <TD width="1%" rowspan="4" valign="top"><IMG src="{$common.imx}{$icon}" width="32" height="32"/></TD>
            <TD><B><xsl:value-of select="dialog/head/title"/></B></TD>
          </TR>
          <TR>
            <TD>
              <xsl:for-each select="dialog/body/p">
                <P><SMALL><xsl:value-of select="."/></SMALL></P>
              </xsl:for-each>
            </TD>
          </TR>
        </TABLE>

      </BODY>
    </HTML>
  </xsl:template>
</xsl:stylesheet>
