<!DOCTYPE html [
  <!ENTITY nbsp "<xsl:text disable-output-escaping='yes'>&amp;nbsp;</xsl:text>">
  <!ENTITY copy "<xsl:text disable-output-escaping='yes'>&amp;copy;</xsl:text>">
  <!ENTITY ampersand "<xsl:text disable-output-escaping='yes'>&amp;</xsl:text>">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:include href="common.xsl"/>
  <xsl:include href="downloadControl.xsl"/>
  <xsl:include href="../../js-import.xsl"/>
  <xsl:template match="/">
    <HTML>
      <HEAD>
        <TITLE>Login - VMware Management Interface</TITLE>
        <SCRIPT>
          <xsl:variable name="script"><xsl:call-template name="js"/></xsl:variable>
          <xsl:value-of select="$script"/>
          <xsl:call-template name="js-src">
            <xsl:with-param name="src">../../util-js.xml</xsl:with-param>
            <xsl:with-param name="use">
              <obj>toBase64</obj>
              <obj>fromBase64</obj>
            </xsl:with-param>
          </xsl:call-template>
        </SCRIPT>
        <LINK rel="stylesheet" href="{$common}style.css" type="text/css" />
      </HEAD>
      <BODY bgcolor="#FFFFFF" onLoad="setup();">
        <BR />
        <P><CENTER>
          <TABLE border="0" cellpadding="0" cellspacing="0"><TR><TD bgcolor="#66664D">
            <TABLE width="100%" border="0" cellpadding="6" cellspacing="1"><TR><TD bgcolor="#CCCCB3">
              <TABLE border="0" cellpadding="0" cellspacing="0">
                  <TR>
                    <TD><small><B>VMware</B> Management Interface</small></TD>
                  </TR>
              </TABLE>
            </TD></TR>
            <TR><TD align="right" bgcolor="#E6E6CC">
              <TABLE border="0" cellpadding="3" cellspacing="0">
                <FORM name="u" method="post" onsubmit="return login();">
                  <xsl:attribute name="action">
                    <xsl:choose>
                      <xsl:when test="/server/host@os = 'MSWin32'">/login/index.pl</xsl:when>
                      <xsl:otherwise>/login</xsl:otherwise>
                    </xsl:choose>
                  </xsl:attribute>
                  <TR>
                    <TD align="right"><SMALL>Username:&nbsp;</SMALL></TD>
                    <TD><INPUT name="v" type="text" value="" size="26" style="font-family:monospace; font-size:12px;"/></TD>
                  </TR>
                </FORM>
                <FORM name="p" method="post" onsubmit="return login();">
                  <xsl:attribute name="action">
                    <xsl:choose>
                      <xsl:when test="/server/host@os = 'MSWin32'">/login/index.pl</xsl:when>
                      <xsl:otherwise>/login</xsl:otherwise>
                    </xsl:choose>
                  </xsl:attribute>
                  <TR>
                    <TD align="right"><SMALL>Password:&nbsp;</SMALL></TD>
                    <TD><INPUT name="v" type="password" value="" size="26" style="font-family:monospace; font-size:12px;"/></TD>
                  </TR>
                </FORM>
                <TR>
                  <TD colspan="2" align="right"><xsl:call-template name="button">
                    <xsl:with-param name="label">Login</xsl:with-param>
                    <xsl:with-param name="action">javascript:loginButton();</xsl:with-param>
                    <xsl:with-param name="gutter-shadow">999980</xsl:with-param>
                    <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                    <xsl:with-param name="edge-shadow">999980</xsl:with-param>
                    <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                    <xsl:with-param name="base">CCCCB3</xsl:with-param>
                  </xsl:call-template></TD>
                </TR>
                <FORM name="k" method="post">
                  <xsl:attribute name="action">
                    <xsl:choose>
                      <xsl:when test="/server/host@os = 'MSWin32'">/login/index.pl</xsl:when>
                      <xsl:otherwise>/login</xsl:otherwise>
                    </xsl:choose>
                  </xsl:attribute>
                  <xsl:variable name="l" select="/server/username"/>
                  <xsl:variable name="n" select="/server/next"/>
                  <INPUT name="l" type="hidden" value="{$l}"/>
                  <INPUT name="m" type="hidden" value=""/>
                  <INPUT name="n" type="hidden" value="{$n}"/>
                </FORM>                                       
              </TABLE>
            </TD></TR></TABLE>
            <table width="100%" border="0" cellpadding="0" cellspacing="0"><tr><td bgcolor="#FFFFFF">&nbsp;</td></tr></table>
            
            <xsl:call-template name="downloadControl">
              <xsl:with-param name="customizeLink">show</xsl:with-param>
            </xsl:call-template>

          </TD></TR></TABLE>
        </CENTER></P>

        <xsl:if test="/server/error">
          <P><CENTER>
            <TABLE><TR>
              <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
              <TD>
                <TABLE border="0" cellpadding="3" cellspacing="0">
                  <TR>
                    <xsl:variable name="icon">error-16.gif</xsl:variable>
                    <TD rowspan="2" valign="top"><IMG src="{$common.imx}{$icon}" width="16" height="16"/></TD>
                    <TD>
                      <P><SMALL><xsl:value-of select="/server/error"/></SMALL></P>
                    </TD>
                  </TR>
                </TABLE>
              </TD>
            <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
            </TR></TABLE>
          </CENTER></P>
        </xsl:if>

        <NOSCRIPT>
          <P><CENTER>
            <TABLE><TR>
              <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
              <TD>
                <TABLE border="0" cellpadding="3" cellspacing="0">
                  <TR>
                    <xsl:variable name="icon">error-16.gif</xsl:variable>
                    <TD rowspan="2" valign="top"><IMG src="{$common.imx}{$icon}" width="16" height="16"/></TD>
                    <TD>
                      <P><SMALL>The VMware Management Interface depends on JavaScript. Please ensure that you are using a compatible browser and that JavaScript is enabled.</SMALL></P>
                    </TD>
                  </TR>
                </TABLE>
              </TD>
              <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
            </TR></TABLE>
          </CENTER></P>
        </NOSCRIPT>

        <SCRIPT>var imx='<xsl:value-of select="$imx"/>'; var commonimx='<xsl:value-of select="$common.imx"/>';<xsl:text disable-output-escaping="yes"><![CDATA[
          var tc='vmware.mui.test';
          var cp=document.cookie.indexOf(tc);
          if (cp==-1) {
          document.write('<P><CENTER>',
          '<TABLE><TR>',
          '<TD><IMG src="'+imx+'spacer.gif" width="128" height="1"/></TD>',
          '<TD>',
          '<TABLE border="0" cellpadding="3" cellspacing="0">',
          '<TR>',
          '<TD rowspan="2" valign="top"><IMG src="'+commonimx+'error-16.gif" width="16" height="16"/></TD>',
          '<TD>',
          '<P><SMALL>The VMware Management Interface depends on HTTP cookies. Please ensure that you are using a compatible browser and that HTTP cookies are enabled.</SMALL></P>',
          '</TD>',
          '</TR>',
          '</TABLE>',
          '</TD>',
          '<TD><IMG src="'+imx+'spacer.gif" width="128" height="1"/></TD>',
          '</TR></TABLE>',
          '</CENTER></P>');
          }
          ]]></xsl:text></SCRIPT>

          <p align="center"><small><small>&copy; 1998-2006 VMware, Inc. All rights reserved. U.S.<br />
          Protected by one or more of U.S. Patent Nos. 6,397,242, 6,496,847, 6,704,925, 6,711,672, 6,725,289, 6,735,601, 6,785,886, 6,789,156, 6,795,966, 6,880,022 6,961,941, 6,961,806 and 6,944,699; patents pending.
          </small></small></p>

      </BODY>
    </HTML>
  </xsl:template>

  <xsl:template name="js"><xsl:text disable-output-escaping="yes"><![CDATA[
    // Wrapper to workaround js bug in Navigator 4.x
    function loginButton() {
      if(validate()) {
        login();
      }
    }

    function validate() {
      if (!document.u.v.value) {
        alert("Please enter a username.");
        document.u.v.focus();
        return false;
      }
      return true;
    }

    function login() {
      if (validate()) {
        document.k.l.value=toBase64(document.u.v.value);
        document.k.m.value=toBase64(document.p.v.value);
        document.k.submit();
      }
      return false;
    }

    function setup() {
      if (parent.unframe) { 
        if (!parent.unframing) {
          parent.unframe(window);
          return;
        }
      }
      document.u.v.focus();
      if (document.k.l.value.length > 0) {
        document.u.v.value = fromBase64(document.k.l.value);
        document.u.v.select();
      }
    }
  ]]></xsl:text></xsl:template>
</xsl:stylesheet>