<!DOCTYPE html [
  <!ENTITY nbsp "<xsl:text disable-output-escaping='yes'>&amp;nbsp;</xsl:text>">
  <!ENTITY ampersand "<xsl:text disable-output-escaping='yes'>&amp;</xsl:text>">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:include href="common.xsl"/>
  <xsl:include href="../../js-import.xsl"/>
  <xsl:template match="/">
    <HTML>
      <HEAD>
        <TITLE>Login - VMware Management Interface</TITLE>
        <SCRIPT>
          <xsl:variable name="script"><xsl:call-template name="js"/></xsl:variable>
          <xsl:value-of select="$script"/>
          <xsl:call-template name="js-src">
            <xsl:with-param name="src">../../util-js.xml</xsl:with-param>
            <xsl:with-param name="use">
              <obj>toBase64</obj>
              <obj>fromBase64</obj>
            </xsl:with-param>
          </xsl:call-template>
        </SCRIPT>
        <LINK rel="stylesheet" href="{$common}style.css" type="text/css" />
      </HEAD>
      <BODY background="{$imx}FFFFFF.png" bgcolor="#FFFFFF" onLoad="setup();">
        <BR />
        <P><CENTER>
          <TABLE border="0" cellpadding="0" cellspacing="0"><TR><TD bgcolor="#66664D" background="{$imx}66664D.png">
            <TABLE border="0" cellpadding="6" cellspacing="1"><TR><TD bgcolor="#CCCCB3" background="{$imx}CCCCB3.png">
              <TABLE border="0" cellpadding="3" cellspacing="0">
                  <TR>
                    <TD align="right"><B>VMware</B> Management Interface</TD>
                  </TR>
              </TABLE>
            </TD></TR>
            <TR><TD bgcolor="#E6E6CC" background="{$imx}E6E6CC.png">
              <TABLE border="0" cellpadding="3" cellspacing="0">
                <FORM name="u" method="post" action="/login/index.pl" onsubmit="return login();">
                  <TR>
                    <TD align="right"><SMALL>Username:&nbsp;</SMALL></TD>
                    <TD><INPUT name="v" type="text" value="" style="font-family: mono"/></TD>
                  </TR>
                </FORM>
                <FORM name="p" method="post" action="/login/index.pl" onsubmit="return login();">
                  <TR>
                    <TD align="right"><SMALL>Password:&nbsp;</SMALL></TD>
                    <TD><INPUT name="v" type="password" value="" style="font-family: mono"/></TD>
                  </TR>
                </FORM>
                <TR>
                  <TD colspan="2" align="right"><xsl:call-template name="button">
                    <xsl:with-param name="label">Login</xsl:with-param>
                    <xsl:with-param name="action">javascript:loginButton();</xsl:with-param>
                    <xsl:with-param name="gutter-shadow">999980</xsl:with-param>
                    <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                    <xsl:with-param name="edge-shadow">999980</xsl:with-param>
                    <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                    <xsl:with-param name="base">CCCCB3</xsl:with-param>
                  </xsl:call-template></TD>
                </TR>
                <FORM name="k" method="post" action="/login/index.pl">
                  <xsl:variable name="l" select="/server/username"/>
                  <xsl:variable name="n" select="/server/next"/>
                  <INPUT name="l" type="hidden" value="{$l}"/>
                  <INPUT name="m" type="hidden" value=""/>
                  <INPUT name="n" type="hidden" value="{$n}"/>
                </FORM>                                       
              </TABLE>
            </TD></TR></TABLE>
          </TD></TR></TABLE>
        </CENTER></P>

        <xsl:if test="/server/error">
          <P><CENTER>
            <TABLE><TR>
              <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
              <TD>
                <TABLE border="0" cellpadding="3" cellspacing="0">
                  <TR>
                    <xsl:variable name="icon">error-16.gif</xsl:variable>
                    <TD rowspan="2" valign="top"><IMG src="{$common.imx}{$icon}" width="16" height="16"/></TD>
                    <TD>
                      <P><SMALL><xsl:value-of select="/server/error"/></SMALL></P>
                    </TD>
                  </TR>
                </TABLE>
              </TD>
            <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
            </TR></TABLE>
          </CENTER></P>
        </xsl:if>

        <NOSCRIPT>
          <P><CENTER>
            <TABLE><TR>
              <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
              <TD>
                <TABLE border="0" cellpadding="3" cellspacing="0">
                  <TR>
                    <xsl:variable name="icon">error-16.gif</xsl:variable>
                    <TD rowspan="2" valign="top"><IMG src="{$common.imx}{$icon}" width="16" height="16"/></TD>
                    <TD>
                      <P><SMALL>The VMware Management Interface depends on JavaScript. Please ensure that you are using a compatible browser and that JavaScript is enabled.</SMALL></P>
                    </TD>
                  </TR>
                </TABLE>
              </TD>
              <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
            </TR></TABLE>
          </CENTER></P>
        </NOSCRIPT>

        <SCRIPT>var imx='<xsl:value-of select="$imx"/>'; var commonimx='<xsl:value-of select="$common.imx"/>';<xsl:text disable-output-escaping="yes"><![CDATA[
          var tc='vmware.mui.test';
          var cp=document.cookie.indexOf(tc);
          if (cp==-1) {
          document.write('<P><CENTER>',
          '<TABLE><TR>',
          '<TD><IMG src="'+imx+'spacer.gif" width="128" height="1"/></TD>',
          '<TD>',
          '<TABLE border="0" cellpadding="3" cellspacing="0">',
          '<TR>',
          '<TD rowspan="2" valign="top"><IMG src="'+commonimx+'error-16.gif" width="16" height="16"/></TD>',
          '<TD>',
          '<P><SMALL>The VMware Management Interface depends on HTTP cookies. Please ensure that you are using a compatible browser and that HTTP cookies are enabled.</SMALL></P>',
          '</TD>',
          '</TR>',
          '</TABLE>',
          '</TD>',
          '<TD><IMG src="'+imx+'spacer.gif" width="128" height="1"/></TD>',
          '</TR></TABLE>',
          '</CENTER></P>');
          }
          ]]></xsl:text></SCRIPT>

      </BODY>
    </HTML>
  </xsl:template>

  <xsl:template name="js"><xsl:text disable-output-escaping="yes"><![CDATA[
    //wrapper to workaround js bug in IE
    function loginButton() {
      if(validate()) {
        login();
      }
    }

    function validate() {
      if (!document.u.v.value) {
        alert("Please enter a username");
        document.u.v.focus();
        return false;
      }
      return true;
    }

    function login() {
      if (validate()) {
        document.k.l.value=toBase64(document.u.v.value);
        document.k.m.value=toBase64(document.p.v.value);
        document.k.submit();
      }
      return false;
    }

    function setup() {
      document.u.v.focus();
      if (document.k.l.value.length > 0) {
        document.u.v.value = fromBase64(document.k.l.value);
        document.u.v.select();
      }
    }
  ]]></xsl:text></xsl:template>
</xsl:stylesheet>
