<!DOCTYPE html [
<!ENTITY nbsp "<xsl:text disable-output-escaping='yes'>&amp;nbsp;</xsl:text>">
<!ENTITY ampersand "<xsl:text disable-output-escaping='yes'>&amp;</xsl:text>">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:template name="help-src">
    <xsl:param name="src"/>
    <TABLE width="100%" border="0" cellpadding="0" cellspacing="0">
      <TR bgcolor="#999980"><TD>
        <TABLE width="100%" border="0" cellpadding="5" cellspacing="1"><TR>
          <TD width="70%" valign="top" bgcolor="#FFFFFF">
            <xsl:apply-templates select="document($src)/*/pageHelp"/>
          </TD>
          <TD width="30%" valign="top" bgcolor="#E6E6CC">
            <xsl:apply-templates select="document($src)/*/legend"/>
          </TD>
        </TR></TABLE>
      </TD></TR>
    </TABLE>
  </xsl:template>
  
  <xsl:template match="pageHelp">
    <TABLE width="100%" border="0" cellspacing="3" cellpadding="0">
      <xsl:for-each select="entry">
        <TR>
          <TD>
            <TABLE width="100%" border="0" cellpadding="3" cellspacing="0"><TR><TD bgcolor="#66664D"><SMALL><B><FONT color="#FFFFFF"><xsl:value-of select="label"/></FONT></B></SMALL></TD></TR></TABLE>
            <xsl:copy-of select="body/*"/>
          </TD>
        </TR>
        <xsl:if test="not(position()=last())"><TR><TD>&nbsp;</TD></TR></xsl:if>
      </xsl:for-each>
    </TABLE>
  </xsl:template>

  <xsl:template match="legend">
    <TABLE width="100%" border="0" cellspacing="3" cellpadding="1">
      <TR><TD bgcolor="#66664D"><TABLE width="100%" border="0" cellpadding="3" cellspacing="0">
        <TR>
          <TD colspan="2" bgcolor="#66664D"><SMALL><B><FONT color="#FFFFFF">Legend</FONT></B></SMALL></TD>
        </TR>
        <xsl:for-each select="entry">
          <TR><TD colspan="2" bgcolor="#999980"><IMG src="{$imx}spacer.gif" width="1" height="1"/></TD></TR>
          <TR>
            <TD rowspan="2" align="center" valign="baseline" bgcolor="#CCCCB3" nowrap="true"><NOBR>
              <xsl:for-each select="symbol">
                <IMG src="{$common.imx}{@src}" width="{@width}" height="{@height}"/>
                <xsl:if test="not(position()=last())"><BR /></xsl:if>
              </xsl:for-each>
            </NOBR></TD>
            <TD bgcolor="#FFFFE6"><SMALL><xsl:value-of select="label"/></SMALL></TD>
          </TR>
          <TR>
            <TD bgcolor="#FFFFE6"><SMALL><SMALL><xsl:copy-of select="body/*"/></SMALL></SMALL></TD>
          </TR>
        </xsl:for-each>
      </TABLE></TD></TR>
    </TABLE>
  </xsl:template>

</xsl:stylesheet>