<?xml version="1.0" encoding="iso-8859-1"?>
<!-- Todo:

     [!DOCTYPE] Put common enitity declarations into a DTD. But DTDs don't seem
     to be working correctly. Hmmm.

  -->
<!DOCTYPE html [
<!ENTITY nbsp "<xsl:text disable-output-escaping='yes'>&amp;nbsp;</xsl:text>">
<!ENTITY ampersand "<xsl:text disable-output-escaping='yes'>&amp;</xsl:text>">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <!-- [ ! ] --><xsl:include href="common.xsl"/>
  <xsl:include href="../../js-import.xsl"/>
  <xsl:include href="pageHelp.xsl"/>
  <xsl:include href="controlmenu.xsl"/>

  <xsl:variable name="vm_colspan">17</xsl:variable>

  <xsl:template match="/">
    <HTML>
      <HEAD>
        <TITLE><xsl:value-of select="/server/vm/displayName"/> Resource Editor - <xsl:value-of select="/server/host"/>.<xsl:value-of select="/server/host@domain"/></TITLE>
        <SCRIPT>
          <xsl:choose>
            <xsl:when test="/server/product@id='ESX'">
              var product = "ESX";
            </xsl:when>
            <xsl:otherwise>
              var product = "GSX";
            </xsl:otherwise>
          </xsl:choose>
          var noRefresh = true;
          //var refreshRate = new Array( );
          //refreshRate['minutes'] = '3';
          //refreshRate['seconds'] = '0';
          var hostOS = "<xsl:value-of select="/server/host@os"/>";
          <xsl:call-template name="js-src">
            <xsl:with-param name="src">../../util-js.xml</xsl:with-param>
            <xsl:with-param name="use">
              <obj use-recommended="1">Is</obj>
            </xsl:with-param>
          </xsl:call-template>
          <xsl:call-template name="js-src">
            <xsl:with-param name="src">controlmenu-js.xml</xsl:with-param>
          </xsl:call-template>
        </SCRIPT>
	<SCRIPT>
         function checkAndSubmit() {
           <xsl:if test="/server/vm/@type = 'vmm'">
	     var memmin;
	     var memmax;

             if (window.document.form.memory_min.value.length != 0) {
                memmin = parseInt(window.document.form.memory_min.value);
		if ((memmin == Number.NaN) || (memmin.toString() != window.document.form.memory_min.value) || !(memmin >= 0)) {
	           alert("Minimum memory value should be a valid positive integer ");
		   return;
                }
             }
	     else {
	        memmin = -1;
	     }

             <xsl:choose>
               <xsl:when test="/server/vm/memory/config_max@write=1 and /server/vm/state=0">
                 if (window.document.form.memory_max.value.length != 0) {
                    memmax = parseInt(window.document.form.memory_max.value);
	   	    if ((memmax == Number.NaN) || (memmax.toString() != window.document.form.memory_max.value) || !(memmax >= 0)) {
	               alert("Maximum memory value should be a valid positive integer ");
		       return;
                    }
                 }
		 else {
 	  	    memmax = -1;
 		 }
               </xsl:when>
               <xsl:otherwise>
                 <xsl:choose>
                   <xsl:when test="/server/vm/state=1">
                     var memmax = parseInt(<xsl:value-of select="/server/vm/memory/max"/>);
                   </xsl:when>
                   <xsl:otherwise>
                     var memmax = <xsl:value-of select="/server/vm/memory/config_max"/>
                   </xsl:otherwise>
                 </xsl:choose>
               </xsl:otherwise>
             </xsl:choose>


            if (memmin != -1 ) {
                if (memmax != -1) {
                   if (memmin > memmax) {
                      alert("Minimum memory setting should be less than Maximum memory setting ");
                      return;
                   }
                }
             }

             var cpumin;
             var cpumax;

             if (window.document.form.cpu_min.value.length != 0) {
                cpumin = parseInt(window.document.form.cpu_min.value);
		if ((cpumin == Number.NaN) || (cpumin.toString() != window.document.form.cpu_min.value) || !(cpumin >= 0)) {
	           alert("Minimum CPU percentage should be a valid positive integer ");
		   return;
                }
             }
	     else {
	        cpumin = -1;
	     }

             if (window.document.form.cpu_max.value.length != 0) {
                cpumax = parseInt(window.document.form.cpu_max.value);
		if ((cpumax == Number.NaN) || (cpumax.toString() != window.document.form.cpu_max.value) || !(cpumax >= 0)) {
	           alert("Maximum CPU percentage should be a valid positive integer ");
		   return;
                }
             }
	     else {
	        cpumax = -1;
	     }

             if (cpumin != -1 ) {
                if (cpumax != -1) {
                   if (cpumin > cpumax) {
                      alert("Minimum CPU percentage cannot be greater than Maximum CPU percentage ");
                      return;
                   }
                }
             }
           </xsl:if>
             document.form.submit();
         }
 	</SCRIPT>
        <SCRIPT src="{$common}server.js"></SCRIPT>
        <SCRIPT src="{$common}server.js"></SCRIPT>
        <LINK rel="stylesheet" href="{$common}style.css" type="text/css" />
      </HEAD>

      <BODY bgcolor="#FFFFFF" link="#000000" vlink="#000000" topmargin="6" leftmargin="6" marginwidth="6" marginheight="6" onload="setup();ctrlMenuSetup();">
        <xsl:call-template name="poweroffMenu"/>
        <xsl:call-template name="poweronMenu"/>
        <xsl:call-template name="suspendMenu"/>
        <xsl:call-template name="softableMenu"/>
        <xsl:call-template name="readonlyMenu"/>
        <xsl:call-template name="unreachableMenu"/>

        <xsl:call-template name="operationForm"/>

        <FORM name="form" method="POST" action="/resources/editor?c={/server/vm/safe_cfg}">
          <xsl:if test="/server/mui@layout='new'"><input type="hidden" name="mui" value="new"/></xsl:if>
          <input type="hidden" name="edit" value="1"/>
          <input type="hidden" name="world" value="{/server/vm@id}"/>
          <xsl:call-template name="pageHeader">
            <xsl:with-param name="uiPath">
              <location href="/overview">VMs on <xsl:value-of select="/server/host"/><xsl:if test="/server/host@domain">.<xsl:value-of select="/server/host@domain"/></xsl:if></location>
              <location href="/resources">Resource Monitor</location>
              <current>Resource Editor</current>
            </xsl:with-param>
            <xsl:with-param name="xtra_ctrl">
              <xsl:choose>
                <xsl:when test="/server/product@id='ESX'">
                  <xsl:if test="/server/mui@layout='new'">
                    <ctrl>
                      <label>Resources Overview</label>
                      <action>/resources?mui=new</action>
                    </ctrl>
                  </xsl:if>
                </xsl:when>
                <xsl:otherwise><none/></xsl:otherwise>
              </xsl:choose>
            </xsl:with-param>
          </xsl:call-template>

          <xsl:if test="/server/success">
            <p>
              <table><tr>
                <td><img src="{$imx}spacer.gif" width="128" height="1"/></td>
                <td>
                  <table border="0" cellpadding="5" cellspacing="0">
                    <tr>
                      <xsl:variable name="icon">info.gif</xsl:variable>
                      <td rowspan="2" valign="top"><IMG src="{$common.imx}{$icon}" width="32" height="32"/></td>
                      <td><b>Success</b></td>
                    </tr>
                    <tr>
                      <td>
                        <p><small>The requested changes have been applied.<br/><small>Go to:
                           <xsl:choose>
                              <xsl:when test="/server/mui@layout='new'">
                                 <a href="/resources?mui=new">Resource Monitor</a>
                              </xsl:when>
                              <xsl:otherwise>
                                 <a href="/resources">Resource Monitor</a>
                              </xsl:otherwise>
                           </xsl:choose>
                         </small></small></p>
                      </td>
                    </tr>
                  </table>
                </td>
                <td><img src="{$imx}spacer.gif" width="128" height="1"/></td>
              </tr></table>
            </p>
          </xsl:if>

          <xsl:if test="not(/server/username='root')">
            <p>
              <table><tr>
                <td><img src="{$imx}spacer.gif" width="128" height="1"/></td>
                <td>
                  <table border="0" cellpadding="5" cellspacing="0">
                    <tr>
                      <xsl:variable name="icon">info.gif</xsl:variable>
                      <td rowspan="2" valign="top"><IMG src="{$common.imx}{$icon}" width="32" height="32"/></td>
                      <td><b>Notice</b></td>
                    </tr>
                    <tr>
                      <td>
                        <p><small>You must login as the root user in order to modify resource allocations.</small></p>
                      </td>
                    </tr>
                  </table>
                </td>
                <td><img src="{$imx}spacer.gif" width="128" height="1"/></td>
              </tr></table>
            </p>
          </xsl:if>

          <xsl:if test="/server/error or /server/messages/msg[@severity='error']">
            <P>
              <TABLE><TR>
                <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
                <TD>
                  <xsl:call-template name="error"/>
                </TD>
                <TD><IMG src="{$imx}spacer.gif" width="128" height="1"/></TD>
              </TR></TABLE>
            </P>
          </xsl:if>

          <xsl:if test="/server/vm">
            <TABLE width="100%" border="0" cellpadding="1" cellspacing="0">
              <TR><TD><IMG src="{$imx}spacer.gif" width="1" height="6"/></TD></TR>
              <TR><TD bgcolor="#999980">
                <TABLE width="100%" border="0" cellpadding="0" cellspacing="0"><TR><TD bgcolor="#FFFFE6"><TABLE width="100%" border="0" cellpadding="3" cellspacing="1">
                  <xsl:call-template name="vmRow">
                    <xsl:with-param name="position"><xsl:value-of select="1"/></xsl:with-param>
                    <xsl:with-param name="stats">
                      <none/>
                    </xsl:with-param>
                    <xsl:with-param name="disable">
                      <needinput/>
                    </xsl:with-param>
                    <xsl:with-param name="states">
                      <xsl:choose>
                        <xsl:when test="/server/vm/@type = 'console'">
                          <none/>
                        </xsl:when>
                        <xsl:otherwise>
                          <off/><suspend/><on/><reset/>
                        </xsl:otherwise>
                      </xsl:choose>
                    </xsl:with-param>
                  </xsl:call-template>
                </TABLE></TD></TR></TABLE>
              </TD></TR>
            </TABLE>

            <table width="100%" border="0" cellpadding="0" cellspacing="0">
              <tr><td><img src="{$imx}spacer.gif" width="1" height="4"/></td></tr>
              <tr>
                <td bgcolor="#999980">
                  <table width="100%" border="0" cellpadding="6" cellspacing="1">
                    <tr>
                      <td bgcolor="#E6E6CC" valign="top">
                        <xsl:variable name="vmm" select="/server/vm/@type = 'vmm'"/>
                        <xsl:call-template name="cpuResources"/>
                        <xsl:if test="$vmm">
                          <xsl:call-template name="memResources"/>
                        </xsl:if>
                        <xsl:for-each select="/server/vm/disk">
                          <xsl:call-template name="diskResources"/>
                        </xsl:for-each>
                        <xsl:if test="$vmm and /server/system/nfshaper = '1'">
                          <xsl:call-template name="netResources"/>
                        </xsl:if>
                      </td>
                    </tr>
                    <xsl:if test="/server/username='root'">
                      <tr>
                        <td bgcolor="#CCCCB3" align="right">
                          <table width="100%" border="0" cellpadding="3" cellspacing="0">
                            <tr>
                              <td align="right">
                                <xsl:call-template name="button">
                                  <xsl:with-param name="label">Undo Changes</xsl:with-param>
                                  <xsl:with-param name="action">javascript:document.form.reset();</xsl:with-param>
                                  <xsl:with-param name="gutter-shadow">999980</xsl:with-param>
                                  <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                                  <xsl:with-param name="edge-shadow">999980</xsl:with-param>
                                  <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                                  <xsl:with-param name="base">E6E6CC</xsl:with-param>
                                </xsl:call-template>
                              </td>
                              <td width="1%" align="right">
                                <xsl:call-template name="button">
                                  <xsl:with-param name="label">Save Changes</xsl:with-param>
                                  <xsl:with-param name="action">javascript:checkAndSubmit();</xsl:with-param>
                                  <xsl:with-param name="gutter-shadow">999980</xsl:with-param>
                                  <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                                  <xsl:with-param name="edge-shadow">999980</xsl:with-param>
                                  <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                                  <xsl:with-param name="base">E6E6CC</xsl:with-param>
                                </xsl:call-template>
                              </td>
                            </tr>
                          </table>
                        </td>
                      </tr>
                    </xsl:if>
                  </table>
                </td>
              </tr>
            </table>
          </xsl:if>

          <P>
            <xsl:call-template name="help-src">
              <xsl:with-param name="src">en/resources-editor.xml</xsl:with-param>
            </xsl:call-template>
          </P>

          <xsl:call-template name="labelFooter"/>
        </FORM>
      </BODY>
    </HTML>
  </xsl:template>

  <xsl:template name="cpuResources">
    <xsl:variable name="running" select="/server/vm/state = 1 or /server/vm/@type = 'console'"/>
    <table width="100%" border="0" cellpadding="3" cellspacing="0">
      <tr><td><small><b>CPU</b></small></td></tr>
      <tr>
        <td>
          <table width="100%" border="0" cellpadding="0" cellspacing="0">
            <tr><td bgcolor="#66664d">
              <table width="100%" border="0" cellpadding="3" cellspacing="1">
                <tr>
                  <td bgcolor="#ffffe6">
                    <table>
                      <tr>
                        <td width="150">
                          <small><small>
                            Shares:
                          </small></small>
                        </td>
                        <td>
                          <small><small>
                            <xsl:choose>
                              <xsl:when test="/server/username='root'">
                                <input type="text" name="cpu_shares" size="6">
                                  <xsl:if test="$running">
                                    <xsl:attribute name="onfocus">storeShares('cpu_shares', 'cpu_total_shares');</xsl:attribute>
                                    <xsl:attribute name="onchange">sumShares('cpu_shares', 'cpu_total_shares');</xsl:attribute>
                                  </xsl:if>
                                  <xsl:attribute name="value">
                                    <xsl:choose>
                                      <xsl:when test="$running"><xsl:value-of select="/server/vm/cpu/shares"/></xsl:when>
                                      <xsl:otherwise><xsl:value-of select="/server/vm/cpu/config_shares"/></xsl:otherwise>
                                    </xsl:choose>
                                  </xsl:attribute>
                                </input>
                              </xsl:when>
                              <xsl:otherwise>
                                <xsl:choose>
                                  <xsl:when test="$running"><xsl:value-of select="/server/vm/cpu/shares"/></xsl:when>
                                  <xsl:otherwise><xsl:value-of select="/server/vm/cpu/config_shares"/></xsl:otherwise>
                                </xsl:choose>
                              </xsl:otherwise>
                            </xsl:choose>
                            &nbsp; configured. &nbsp;
                            <xsl:choose>
                              <xsl:when test="$running and /server/username='root'">
                                <input type="text" name="cpu_total_shares" value="{/server/totals/cpu/shares}" size="6" onfocus="this.blur();"/> &nbsp;
                              </xsl:when>
                              <xsl:otherwise><xsl:value-of select="/server/totals/cpu/shares"/></xsl:otherwise>
                            </xsl:choose>
                            total for all running worlds.
                          </small></small>
                        </td>
                      </tr>
                      <xsl:if test="/server/vm/@type != 'console'">
                      <tr>
                        <td width="150">
                          <small><small>
                            <nobr>Minimum:</nobr>
                          </small></small>
                        </td>
                        <td>
                          <small><small>
                            <xsl:variable name="cpu_min">
                              <xsl:choose>
                                <xsl:when test="$running">
                                  <xsl:value-of select="round(number(/server/vm/cpu/min))" />
                                </xsl:when>
                                <xsl:otherwise>
                                  <xsl:value-of select="/server/vm/cpu/config_min" />
                                </xsl:otherwise>
                              </xsl:choose>
                            </xsl:variable>
                            <xsl:choose>
                              <xsl:when test="/server/username='root'">
                                <input type="text" name="cpu_min" size="4" value="{$cpu_min}" />
                              </xsl:when>
                              <xsl:otherwise>
                                <xsl:value-of select="$cpu_min" />
                              </xsl:otherwise>
                            </xsl:choose> %
                          </small></small>
                        </td>
                      </tr>
                      <tr>
                        <td width="150">
                          <small><small>
                            <nobr>Maximum:</nobr>
                          </small></small>
                        </td>
                        <td>
                          <small><small>
                            <xsl:variable name="cpu_max">
                              <xsl:choose>
                                <xsl:when test="$running">
                                  <xsl:value-of select="round(number(/server/vm/cpu/max))" />
                                </xsl:when>
                                <xsl:otherwise>
                                  <xsl:value-of select="/server/vm/cpu/config_max" />
                                </xsl:otherwise>
                              </xsl:choose>
                            </xsl:variable>
                            <xsl:choose>
                              <xsl:when test="/server/username='root'">
                                <input type="text" name="cpu_max" size="4" value="{$cpu_max}" />
                              </xsl:when>
                              <xsl:otherwise>
                                <xsl:value-of select="$cpu_max" />
                              </xsl:otherwise>
                            </xsl:choose> %
                          </small></small>
                        </td>
                      </tr>
                      <tr>
                        <td width="150">
                          <small><small>
                            <nobr>Only Use Processor(s):</nobr>
                          </small></small>
                        </td>
                        <td>
                          <small><small>
                            <input type="hidden" name="numCPU" value="{/server/system/numCPU}"/>
                            <xsl:for-each select="/server/system/cpus/cpu">
                              <xsl:choose>
                                <xsl:when test="/server/username='root'">
                                  <input type="checkbox" name="cpu_affinity-{@id}" value="{@id}">
                                    <xsl:variable name="id" select="@id"/>
                                    <xsl:choose>
                                      <xsl:when test="$running">
                                        <xsl:if test="/server/vm/cpu/affinity/cpu[@id = $id] = '1'">
                                          <xsl:attribute name="checked">1</xsl:attribute>
                                        </xsl:if>
                                      </xsl:when>
                                      <xsl:otherwise>
                                        <xsl:if test="/server/vm/cpu/config_affinity/cpu[@id = $id] = '1'">
                                          <xsl:attribute name="checked">1</xsl:attribute>
                                        </xsl:if>
                                      </xsl:otherwise>
                                    </xsl:choose>
                                  </input><xsl:text> </xsl:text><xsl:value-of select="@id"/> &nbsp;
                                </xsl:when>
                                <xsl:otherwise>
                                  #<xsl:value-of select="@id"/><xsl:if test="not(position() = last())">, </xsl:if>
                                </xsl:otherwise>
                              </xsl:choose>
                            </xsl:for-each>
                          </small></small>
                        </td>
                      </tr>
                      </xsl:if>
                    </table>
                  </td>
                </tr>
              </table>
            </td></tr>
          </table>
        </td>
      </tr>
    </table>
  </xsl:template>

  <xsl:template name="memResources">
    <xsl:variable name="running" select="/server/vm/state = 1 or /server/vm/@type = 'console'"/>
    <table width="100%" border="0" cellpadding="3" cellspacing="0">
      <tr><td><small><b>RAM</b></small></td></tr>
      <tr>
        <td>
          <table width="100%" border="0" cellpadding="0" cellspacing="0">
            <tr><td bgcolor="#66664d">
              <table width="100%" border="0" cellpadding="3" cellspacing="1">
                <tr>
                  <td bgcolor="#ffffe6">
                    <table>
                      <tr>
                        <td width="150">
                          <small><small>
                            Shares:
                          </small></small>
                        </td>
                        <td>
                          <small><small>
                            <xsl:choose>
                              <xsl:when test="/server/username='root'">
                                <input type="text" name="memory_shares" size="6">
                                  <xsl:if test="$running">
                                    <xsl:attribute name="onfocus">storeShares('memory_shares', 'memory_total_shares');</xsl:attribute>
                                    <xsl:attribute name="onchange">sumShares('memory_shares', 'memory_total_shares');</xsl:attribute>
                                  </xsl:if>
                                  <xsl:attribute name="value">
                                    <xsl:choose>
                                      <xsl:when test="$running"><xsl:value-of select="/server/vm/memory/shares"/></xsl:when>
                                      <xsl:otherwise><xsl:value-of select="/server/vm/memory/config_shares"/></xsl:otherwise>
                                    </xsl:choose>
                                  </xsl:attribute>
                                </input>
                              </xsl:when>
                              <xsl:otherwise>
                                <xsl:choose>
                                  <xsl:when test="$running"><xsl:value-of select="/server/vm/memory/shares"/></xsl:when>
                                  <xsl:otherwise><xsl:value-of select="/server/vm/memory/config_shares"/></xsl:otherwise>
                                </xsl:choose>
                              </xsl:otherwise>
                            </xsl:choose>
                            &nbsp; configured. &nbsp;
                            <xsl:choose>
                              <xsl:when test="$running and /server/username='root'">
                                <input type="text" name="memory_total_shares" value="{/server/totals/memory/shares}" size="6" onfocus="this.blur();"/> &nbsp;
                              </xsl:when>
                              <xsl:otherwise><xsl:value-of select="/server/totals/memory/shares"/></xsl:otherwise>
                            </xsl:choose>
                            total for all running worlds.
                          </small></small>
                        </td>
                      </tr>
                      <tr>
                        <td width="150">
                          <small><small>
                            <nobr>Minimum:</nobr>
                          </small></small>
                        </td>
                        <td>
                          <small><small>
                            <xsl:variable name="mem_min">
                              <xsl:choose>
                                <xsl:when test="$running">
                                  <xsl:value-of select="round(number(/server/vm/memory/min))" />
                                </xsl:when>
                                <xsl:otherwise>
                                  <xsl:value-of select="/server/vm/memory/config_min" />
                                </xsl:otherwise>
                              </xsl:choose>
                            </xsl:variable>
                            <xsl:choose>
                              <xsl:when test="/server/username='root'">
                                <input type="text" name="memory_min" size="4" value="{$mem_min}" />
                              </xsl:when>
                              <xsl:otherwise>
                                <xsl:value-of select="$mem_min" />
                              </xsl:otherwise>
                            </xsl:choose> MB
                          </small></small>
                        </td>
                      </tr>
                      <tr>
                        <td width="150">
                          <small><small>
                            <nobr>Maximum:</nobr>
                          </small></small>
                        </td>
                        <td>
                          <small><small>
                            <xsl:choose>
                              <xsl:when test="/server/vm/memory/config_max@write=1 and not($running)">
                                <input type="text" name="memory_max" size="4" value="{/server/vm/memory/config_max}"/>
                              </xsl:when>
                              <xsl:otherwise>
                                <xsl:choose>
                                  <xsl:when test="$running"><xsl:value-of select="/server/vm/memory/max"/></xsl:when>
                                  <xsl:otherwise><xsl:value-of select="/server/vm/memory/config_max"/></xsl:otherwise>
                                </xsl:choose>
                              </xsl:otherwise>
                            </xsl:choose> MB
                          </small></small>
                        </td>
                      </tr>
                       <tr>
                        <td width="150">
                          <small><small>
                            <nobr>NUMA Affinity Node(s):</nobr>
                          </small></small>
                        </td>
                        <td>
                          <small><small>
                            <input type="hidden" name="numNode" value="{/server/system/numNode}"/>
                            <xsl:for-each select="/server/system/nodes/node">
                              <xsl:choose>
                                <xsl:when test="/server/username='root'">
                                  <input type="checkbox" name="mem_affinity-{@id}" value="{@id}">
                                    <xsl:variable name="id" select="@id"/>
                                    <xsl:choose>
                                      <xsl:when test="$running">
                                        <xsl:if test="/server/vm/memory/affinity/node[@id = $id] = '1'">
                                          <xsl:attribute name="checked">1</xsl:attribute>
                                        </xsl:if>
                                      </xsl:when>
                                      <xsl:otherwise>
                                        <xsl:if test="/server/vm/memory/config_affinity/node[@id = $id] = '1'">
                                          <xsl:attribute name="checked">1</xsl:attribute>
                                        </xsl:if>
                                      </xsl:otherwise>
                                    </xsl:choose>
                                  </input><xsl:text> </xsl:text><xsl:value-of select="@id"/> &nbsp;
                                </xsl:when>
                                <xsl:otherwise>
                                  #<xsl:value-of select="@id"/><xsl:if test="not(position() = last())">, </xsl:if>
                                </xsl:otherwise>
                              </xsl:choose>
                            </xsl:for-each>
                          </small></small>
                        </td>
                      </tr>
                    </table>
                  </td>
                </tr>
              </table>
            </td></tr>
          </table>
        </td>
      </tr>
    </table>
  </xsl:template>

  <xsl:template name="diskResources">
    <xsl:variable name="running" select="/server/vm/state = 1 or /server/vm/@type = 'console'"/>
    <table width="100%" border="0" cellpadding="3" cellspacing="0">
      <tr><td><small><b>Disk&nbsp;<xsl:value-of select="@name"/></b></small></td></tr>
      <tr>
        <td>
          <table width="100%" border="0" cellpadding="0" cellspacing="0">
            <tr><td bgcolor="#66664d">
              <table width="100%" border="0" cellpadding="3" cellspacing="1">
                <tr>
                  <td bgcolor="#ffffe6">
                    <table>
                      <tr>
                        <td width="150">
                          <small><small>
                            Shares:
                          </small></small>
                        </td>
                        <td>
                          <small><small>
                            <xsl:choose>
                              <xsl:when test="/server/username='root'">
                                <input type="text" name="disk_shares_{@name}" size="6">
                                  <xsl:if test="$running">
                                    <xsl:attribute name="onfocus">storeShares('disk_shares_<xsl:value-of select="@name"/>', 'disk_total_shares_<xsl:value-of select="@name"/>');</xsl:attribute>
                                    <xsl:attribute name="onchange">sumShares('disk_shares_<xsl:value-of select="@name"/>', 'disk_total_shares_<xsl:value-of select="@name"/>');</xsl:attribute>
                                  </xsl:if>
                                  <xsl:attribute name="value">
                                    <xsl:choose>
                                      <xsl:when test="$running">
                                        <xsl:value-of select="shares"/>
                                      </xsl:when>
                                      <xsl:otherwise>
                                        <xsl:value-of select="config_shares"/>
                                      </xsl:otherwise>
                                    </xsl:choose>
                                  </xsl:attribute>
                                </input>
                              </xsl:when>
                              <xsl:otherwise>
                                <xsl:choose>
                                  <xsl:when test="$running">
                                    <xsl:value-of select="shares"/>
                                  </xsl:when>
                                  <xsl:otherwise>
                                    <xsl:value-of select="config_shares"/>
                                  </xsl:otherwise>
                                </xsl:choose>
                              </xsl:otherwise>
                            </xsl:choose>
                            &nbsp; configured. &nbsp;
                            <xsl:variable name="name" select="@name"/>
                            <xsl:choose>
                              <xsl:when test="$running and /server/username='root'">
                                <input type="text" name="disk_total_shares_{@name}"
                                       value="{/server/totals/disk[@name = $name]/shares}"
                                       size="6" onfocus="this.blur();"/>&nbsp;
                              </xsl:when>
                              <xsl:otherwise>
                                <xsl:value-of select="/server/totals/disk[@name = $name]/shares"/>
                              </xsl:otherwise>
                            </xsl:choose>
                            total for all running worlds.
                          </small></small>
                        </td>
                      </tr>
                    </table>
                  </td>
                </tr>
              </table>
            </td></tr>
          </table>
        </td>
      </tr>
    </table>
  </xsl:template>

  <xsl:template name="netResources">
    <xsl:variable name="running" select="/server/vm/state = 1 or /server/vm/@type = 'console'"/>
    <table width="100%" border="0" cellpadding="3" cellspacing="0">
      <tr>
        <td width="1%" nowrap="1"><nobr><small><b>Network</b></small></nobr></td>
        <input type="hidden" name="has_filter">
          <xsl:attribute name="value">
            <xsl:choose>
              <xsl:when test="/server/vm/network/filter">1</xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </xsl:attribute>
        </input>
        <xsl:if test="/server/username='root' and $running">
          <td width="1%" nowrap="1"><small><small><input type="radio" name="enable_filter" value="1" onclick="restoreFilter()">
            <xsl:if test="/server/vm/network/filter"><xsl:attribute name="checked">1</xsl:attribute></xsl:if>
          </input></small></small></td>
        </xsl:if>
        <xsl:choose>
          <xsl:when test="$running">
            <td nowrap="1">
              <xsl:if test="/server/username='root' and $running"><xsl:attribute name="width">1%</xsl:attribute></xsl:if>
              <nobr><small><small>
                <xsl:choose>
                  <xsl:when test="/server/username='root' and $running">Enable traffic shaping</xsl:when>
                  <xsl:when test="/server/vm/network/filter">Traffic shaping is enabled</xsl:when>
                  <xsl:otherwise>Traffic shaping is disabled.</xsl:otherwise>
                </xsl:choose>
              </small></small></nobr>
            </td>
            <xsl:if test="/server/username='root' and $running">
              <td width="1%"><small><small><input type="radio" name="enable_filter" value="0" onclick="storeFilter()">
                <xsl:if test="not(/server/vm/network/filter)"><xsl:attribute name="checked">1</xsl:attribute></xsl:if>
              </input></small></small></td>
            </xsl:if>
            <xsl:if test="/server/username='root' and $running">
              <td nowrap="1"><nobr><small><small>Disable traffic shaping</small></small></nobr></td>
            </xsl:if>
          </xsl:when>
          <xsl:otherwise>
            <td nowrap="1"><nobr><small><small>Traffic shaping is not available while the virtual machine is not powered on.</small></small></nobr></td>
          </xsl:otherwise>
        </xsl:choose>
      </tr>
      <xsl:if test="$running and (/server/username='root' or /server/vm/network/filter)">
        <tr>
          <td colspan="5">
            <table width="100%" border="0" cellpadding="0" cellspacing="0">
              <tr><td bgcolor="#66664d">
                <table width="100%" border="0" cellpadding="3" cellspacing="1">
                  <tr>
                    <td bgcolor="#ffffe6">
                      <table>
                        <tr>
                          <td width="150">
                            <small><small>
                              Average:
                            </small></small>
                          </td>
                          <td>
                            <small><small>
                              <xsl:choose>
                                <xsl:when test="/server/username='root'">
                                  <input name="avg_bandwidth" size="9" onchange="this.form.enable_filter[0].checked=true;">
                                    <xsl:attribute name="value">
                                      <xsl:choose>
                                        <xsl:when test="/server/vm/network/filter">
                                          <xsl:value-of select="/server/vm/network/filter/avg_bandwidth div 1000000"/>
                                        </xsl:when>
                                        <xsl:otherwise/>
                                      </xsl:choose>
                                    </xsl:attribute>
                                  </input>
                                </xsl:when>
                                <xsl:otherwise>
                                  <xsl:value-of select="/server/vm/network/filter/avg_bandwidth div 1000000"/>
                                </xsl:otherwise>
                              </xsl:choose>
                              Mbps
                            </small></small>
                          </td>
                        </tr>
                        <tr>
                          <td width="150">
                            <small><small>
                              Peak:
                            </small></small>
                          </td>
                          <td>
                            <small><small>
                              <xsl:choose>
                                <xsl:when test="/server/username='root'">
                                  <input name="peak_bandwidth" size="9" onchange="this.form.enable_filter[0].checked=true;">
                                    <xsl:attribute name="value">
                                      <xsl:choose>
                                        <xsl:when test="/server/vm/network/filter">
                                          <xsl:value-of select="/server/vm/network/filter/peak_bandwidth div 1000000"/>
                                        </xsl:when>
                                        <xsl:otherwise/>
                                      </xsl:choose>
                                    </xsl:attribute>
                                  </input>
                                </xsl:when>
                                <xsl:otherwise>
                                  <xsl:value-of select="/server/vm/network/filter/peak_bandwidth div 1000000"/>
                                </xsl:otherwise>
                              </xsl:choose>
                              Mbps
                            </small></small>
                          </td>
                        </tr>
                        <tr>
                          <td width="150">
                            <small><small>
                              Burst:
                            </small></small>
                          </td>
                          <td>
                            <small><small>
                              <xsl:choose>
                                <xsl:when test="/server/username='root'">
                                  <input name="burst_size" size="9" onchange="this.form.enable_filter[0].checked=true;">
                                    <xsl:attribute name="value">
                                      <xsl:choose>
                                        <xsl:when test="/server/vm/network/filter">
                                          <xsl:value-of select="/server/vm/network/filter/burst_size div 1000"/>
                                        </xsl:when>
                                        <xsl:otherwise/>
                                      </xsl:choose>
                                    </xsl:attribute>
                                  </input>
                                </xsl:when>
                                <xsl:otherwise>
                                  <xsl:value-of select="/server/vm/network/filter/burst_size div 1000"/>
                                </xsl:otherwise>
                              </xsl:choose>
                              KB
                            </small></small>
                          </td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                </table>
              </td></tr>
            </table>
          </td>
        </tr>
      </xsl:if>
    </table>
  </xsl:template>
</xsl:stylesheet>
