/* GUI States
 * 
 */
var NUM_STATES = 4;
var NORMAL = 0, PRELIGHT = 1, ACTIVE = 2, DISABLED = 3;

/* Server actions (most are overloaded to imply status)
 *  
 */
var UNREACHABLE = -1, POWEROFF = 0, POWERON = 1, SUSPEND = 2, RESET = 3, STUCK = 4, BUSY = 5, REMOTE = 6;
var imx = new Array( );

var base_href = window.location.protocol + '//' + window.location.host;

function setup( ) {
  /* Status images
  *  
  */
  if ( document.images ) {
    imx[ POWERON ] = new Array ( NUM_STATES );
    imx[ POWEROFF ] = new Array ( NUM_STATES );
    imx[ SUSPEND ] = new Array ( NUM_STATES );
    imx[ RESET ] = new Array ( NUM_STATES );
    imx[ REMOTE ] = new Array ( NUM_STATES );

    imx[ POWERON ][ NORMAL ] = new Image( 17, 17 );
    imx[ POWERON ][ PRELIGHT ] = new Image( 17, 17 );
    imx[ POWERON ][ ACTIVE ] = new Image( 17, 17 );
    imx[ POWERON ][ DISABLED ] = new Image( 17, 17 );
    imx[ POWERON ][ NORMAL ].src = base_href+'/vmware/themes/default/imx/POWERON_rb-0.gif';
    imx[ POWERON ][ PRELIGHT ].src = base_href+'/vmware/themes/default/imx/POWERON_rb-1.gif';
    imx[ POWERON ][ ACTIVE ].src = base_href+'/vmware/themes/default/imx/POWERON_rb-2.gif';
    imx[ POWERON ][ DISABLED ].src = base_href+'/vmware/themes/default/imx/POWERON_rb-3.gif';

    imx[ POWEROFF ][ NORMAL ] = new Image( 17, 17 );
    imx[ POWEROFF ][ PRELIGHT ] = new Image( 17, 17 );
    imx[ POWEROFF ][ ACTIVE ] = new Image( 17, 17 );
    imx[ POWEROFF ][ DISABLED ] = new Image( 17, 17 );
    imx[ POWEROFF ][ NORMAL ].src = base_href+'/vmware/themes/default/imx/POWEROFF_rb-0.gif';
    imx[ POWEROFF ][ PRELIGHT ].src = base_href+'/vmware/themes/default/imx/POWEROFF_rb-1.gif';
    imx[ POWEROFF ][ ACTIVE ].src = base_href+'/vmware/themes/default/imx/POWEROFF_rb-2.gif';
    imx[ POWEROFF ][ DISABLED ].src = base_href+'/vmware/themes/default/imx/POWEROFF_rb-3.gif';

    imx[ SUSPEND ][ NORMAL ] = new Image( 17, 17 );
    imx[ SUSPEND ][ PRELIGHT ] = new Image( 17, 17 );
    imx[ SUSPEND ][ ACTIVE ] = new Image( 17, 17 );
    imx[ SUSPEND ][ DISABLED ] = new Image( 17, 17 );
    imx[ SUSPEND ][ NORMAL ].src = base_href+'/vmware/themes/default/imx/SUSPEND_rb-0.gif';
    imx[ SUSPEND ][ PRELIGHT ].src = base_href+'/vmware/themes/default/imx/SUSPEND_rb-1.gif';
    imx[ SUSPEND ][ ACTIVE ].src = base_href+'/vmware/themes/default/imx/SUSPEND_rb-2.gif';
    imx[ SUSPEND ][ DISABLED ].src = base_href+'/vmware/themes/default/imx/SUSPEND_rb-3.gif';

    imx[ RESET ][ NORMAL ] = new Image( 17, 17 );
    imx[ RESET ][ PRELIGHT ] = new Image( 17, 17 );
//     imx[ RESET ][ ACTIVE ] = new Image( 17, 17 );
    imx[ RESET ][ DISABLED ] = new Image( 17, 17 );
    imx[ RESET ][ NORMAL ].src = base_href+'/vmware/themes/default/imx/RESET_rb-0.gif';
    imx[ RESET ][ PRELIGHT ].src = base_href+'/vmware/themes/default/imx/RESET_rb-1.gif';
//     imx[ RESET ][ ACTIVE ].src = '/vmware/themes/default/imx/RESET_rb-2.gif';
    imx[ RESET ][ DISABLED ].src = base_href+'/vmware/themes/default/imx/RESET_rb-3.gif';

    imx[ REMOTE ][ NORMAL ] = new Image( 17, 17 );
    imx[ REMOTE ][ PRELIGHT ] = new Image( 17, 17 );
//     imx[ REMOTE ][ ACTIVE ] = new Image( 17, 17 );
//     imx[ REMOTE ][ DISABLED ] = new Image( 17, 17 );
    imx[ REMOTE ][ NORMAL ].src = base_href+'/vmware/themes/default/imx/rd-0.gif';
    imx[ REMOTE ][ PRELIGHT ].src = base_href+'/vmware/themes/default/imx/rd-1.gif';
//     imx[ REMOTE ][ ACTIVE ].src = '/vmware/themes/default/imx/rd-2.gif';
//     imx[ REMOTE ][ DISABLED ].src = '/vmware/themes/default/imx/rd-3.gif';
  }

  if (!window.refreshRate && !window.noRefresh) {
    refreshRate = new Array( );
    refreshRate['minutes'] = '3';
    refreshRate['seconds'] = '0';
  }

  if (!window.noRefresh) {
    window.setTimeout( 'window.location.reload( )', 
                       1000 *
                       ((60*parseInt(refreshRate['minutes'].length>0?refreshRate['minutes']:3))
                        + parseInt(refreshRate['seconds'].length>0?refreshRate['seconds']:0)));
  }
  return true;
}

function showState(state, i) {
  switch(parseInt(state)) {
    case -1:
      showUnreachable(i);
      break;
    case 0:
      showPowerOff(i);
      break;
    case 1:
      showPowerOn(i);
      break;
    case 2:
      showSuspend(i);
      break;
    case 4:
      showUnreachable(i);
      break;
    default:
      break;
  }
}

function showUnreachable( which ) {
  var wid = 'vm' + which;
  if ( !document.images )
    return;
  if(document.images[ wid + '.' + POWEROFF ]) document.images[ wid + '.' + POWEROFF ].src = imx[ POWEROFF ][ DISABLED ].src;
  if(document.images[ wid + '.' + SUSPEND ]) document.images[ wid + '.' + SUSPEND ].src = imx[ SUSPEND ][ DISABLED ].src;
  if(document.images[ wid + '.' + POWERON ]) document.images[ wid + '.' + POWERON ].src = imx[ POWERON ][ DISABLED ].src;
  if(document.images[ wid + '.' + RESET ]) document.images[ wid + '.' + RESET ].src = imx[ RESET ][ DISABLED ].src;
}

function showBusy(which, op) {
  var wid = 'vm' + which;
  if ( !document.images )
    return;
  var busy_signal = PRELIGHT;
  if ( document.images[ wid + '.' + op ] && imx[ op ][ PRELIGHT ].src == document.images[ wid + '.' + op ].src ) {
    busy_signal = NORMAL;
  }

  if(document.images[ wid + '.' + POWEROFF ]) document.images[ wid + '.' + POWEROFF ].src = imx[ POWEROFF ][( op != POWEROFF ? DISABLED : busy_signal )].src;
  if(document.images[ wid + '.' + SUSPEND ]) document.images[ wid + '.' + SUSPEND ].src = imx[ SUSPEND ][( op != SUSPEND ? DISABLED : busy_signal )].src;
  if(document.images[ wid + '.' + POWERON ]) document.images[ wid + '.' + POWERON ].src = imx[ POWERON ][( op != POWERON ? DISABLED : busy_signal )].src;
  if(document.images[ wid + '.' + RESET ]) document.images[ wid + '.' + RESET ].src = imx[ RESET ][( op != RESET ? DISABLED : busy_signal )].src;
  window.setTimeout("showBusy('" + which + "'," + op + ")", 250);
}

function showPowerOff( which ) {
  var wid = 'vm' + which;
  if ( !document.images )
    return;
  if(document.images[ wid + '.' + POWEROFF ]) document.images[ wid + '.' + POWEROFF ].src = imx[ POWEROFF ][ ACTIVE ].src;
  if(document.images[ wid + '.' + SUSPEND ]) document.images[ wid + '.' + SUSPEND ].src = imx[ SUSPEND ][ DISABLED ].src;
  if(document.images[ wid + '.' + POWERON ]) document.images[ wid + '.' + POWERON ].src = imx[ POWERON ][ NORMAL ].src;
  if(document.images[ wid + '.' + RESET ]) document.images[ wid + '.' + RESET ].src = imx[ SUSPEND ][ DISABLED ].src;
}

function showPowerOn( which ) {
  var wid = 'vm' + which;
  if ( !document.images )
    return;
  if(document.images[ wid + '.' + POWEROFF ]) document.images[ wid + '.' + POWEROFF ].src = imx[ POWEROFF ][ NORMAL ].src;
  if (resumed(which) && repeatable(which)) { 
    if(document.images[ wid + '.' + SUSPEND ]) document.images[ wid + '.' + SUSPEND ].src = imx[ SUSPEND ][ DISABLED ].src;
  } else {
    if(document.images[ wid + '.' + SUSPEND ]) document.images[ wid + '.' + SUSPEND ].src = imx[ SUSPEND ][ NORMAL ].src;
  }
  if(document.images[ wid + '.' + POWERON ]) document.images[ wid + '.' + POWERON ].src = imx[ POWERON ][ ACTIVE ].src;
  if(document.images[ wid + '.' + RESET ]) document.images[ wid + '.' + RESET ].src = imx[ RESET ][ NORMAL ].src;
}

function showSuspend( which ) {
  var wid = 'vm' + which;
  if ( !document.images )
    return;
  if(document.images[ wid + '.' + POWEROFF ]) document.images[ wid + '.' + POWEROFF ].src = imx[ POWEROFF ][ DISABLED ].src;
  if(document.images[ wid + '.' + SUSPEND ]) document.images[ wid + '.' + SUSPEND ].src = imx[ SUSPEND ][ ACTIVE ].src;
  if(document.images[ wid + '.' + POWERON ]) document.images[ wid + '.' + POWERON ].src = imx[ POWERON ][ NORMAL ].src;
  if(document.images[ wid + '.' + RESET ]) document.images[ wid + '.' + RESET ].src = imx[ RESET ][ DISABLED ].src;
}

var imgSrc = new Array( );

function prelightVM( which, type ) {
  if ( !document.images || !imx || imx.length <= 0 || getState( which ) == BUSY )
    return false;
  var img = 'vm' + which + '.' + type;
  var state = parseInt(getState( which ));
  switch( state ) {
    case -1:
      state = "unreachable";
      break;
    case 0:
      state = "off";
      break;
    case 1:
      state = "on";
      break;
    case 2:
      state = "suspended";
      break;
    case 4:
      state = "waiting for input";
      break;
    default:
      state = "in an unknown state";
      break;
  }
  if ( document.images[ img ].src == imx[ type ][ NORMAL ].src ) {
    imgSrc[ img ] = document.images[ img ].src;
    document.images[ img ].src = imx[ type ][ PRELIGHT ].src;
    switch( type ) {
      case 0:
        hint( 'Shut down the guest operating system.');
        break;
      case 1:
        hint( ( getState( which ) == SUSPEND ? 'Run script after resume.' : 'Power the VM on.' ));
        break;
      case 2:
        hint( 'Run script before suspend.');
        break;
      case 3:
        hint( 'Restart the guest operating system.');
        break;
      case 6:
        hint( 'Open virtual machine menu.' );
        break;
      default:
        hint( '' );
        break;
    }
  } else if ( document.images[ img ].src != imx[ type ][ DISABLED ].src ) {
    switch( type ) {
      case 0:
        hint( 'The VM is off.');
        break;
      case 1:
        hint( 'The VM is on.');
        break;
      case 2:
        hint( 'Resume the virtual machine.');
        break;
      default:
        hint( '');
        break;
    }
  } else if (!executable( which )) {
    switch( type ) {
      case 0:
        hint( 'You are not authorized to power the VM off.' );
        break;
      case 1:
        hint( 'You are not authorized to power the VM on.' );
        break;
      case 2:
        hint( 'You are not authorized to suspend the VM.' );
        break;
      case 3:
        hint( 'You are not authorized to reset the VM.' );
        break;
      default:
        hint( '' );
        break;
    }
  } else {
    switch( type ) {
      case 0:
        hint( 'The guest operating system cannot be shut down if ' + (state=='on'?'the server tools are not available':'the virtual machine is '+state) + '.' );
        break;
      case 1:
        hint( 'The virtual machine cannot be powered on if it is ' + state + '.' );
        break;
      case 2:
          hint( (state=='on'?'A script cannot be run before suspending the virtual machine if repeatable resume is active':'The virtual machine cannot be suspended if it is '+state) + '.' );
        break;
      case 3:
        hint( 'The guest operating system cannot be restarted if ' + (state=='on'?'the server tools are not available':'the virtual machine is '+state) + '.' );
        break;
      default:
        hint( '' );
        break;
    }
  }
  return true;
}

function postlightVM( which, type ) {
  if ( !document.images || !imx || imx.length <= 0 || getState( which ) == BUSY )
    return false;
  var img = 'vm' + which + '.' + type;

  if ( imgSrc[ img ] ) {
    document.images[ img ].src = imgSrc[ img ];
    imgSrc[ img ] = null;
  }
  return hint( '' );
}

/* Utilities
 *
 */
function noop( ) {
  ;
}

function hint( s ) {
  window.status = s || '';
  return true;
}

function getState( which ) {
  var f = window.document.form;
  if ( f.vmState[1] ) {
    return f.vmState[ which ].value;
  } else {
    return f.vmState.value;
  }
}

function isSoftable( which ) {
  var f = window.document.form;
  if ( f.vmSoftable[1] ) {
    return f.vmSoftable[ which ].value == 1;
  } else {
    return f.vmSoftable.value == 1;
  }
}

function setState( which, state ) {
  var f = window.document.form;
  if ( f.vmState[1] ) {
    f.vmState[ which ].value = state;
  } else {
    f.vmState.value = state;
  }
}

function console( which ) {
  var wid = 'vm' + which;
  var state = getState( which );

  if ( state == UNREACHABLE || !executable(which) ) {
    aggressiveUpdate();
    return;
  }
  which = getCfg( which );

  // There doesn't seem to be any good way to convince IE4 that the filename
  // is *.xvm short of modifying the URL. /vmware-console will accept a vm
  // argument with a *.xvm extension and convert it to *.cfg.
  if(hostOS == "MSWin32") {
    window.location.href='/vmware-console/index.xvm?vm=' + which + '.xvm';
  } else {
    window.location.href='/vmware-console?vm=' + which + '.xvm';
  }
  if(ctrlMenu && ctrlMenu.length)unCtrlMenu();
  aggressiveUpdate();
}

var width = 640;
var height = 480;
var browser, version, os;

function getSysInfo() {
  if(is.ie != 0) {
    browser = 'ie';
    version = is.ie;
  } else if(is.nn != 0) {
    browser = 'netscape';
    version = is.nn;
  } else {
    browser = 'unknown';
    version = 0;
  }

  if(is.win)      os = 'win';
  else if(is.x11) os = 'x11';
  else if(is.os2) os = 'os2';
  else if(is.mac) os = 'mac';
  else            os = 'unknown';
} 

function rc( which, service, ext ) {
  var wid = 'vm' + which;
  var state = getState( which );
  getSysInfo();

  if ( state == UNREACHABLE || !executable(which) ) {
    aggressiveUpdate();
    return;
  }
  which = getCfg( which );

  var win;
  // On Windows, the only file available under /vmware-rc is index.pl
  // On Linux, the entire directory is handled by RC.pm
  if(hostOS == "MSWin32") {
    win = window.open("/vmware-rc/index." + "pl" + "?os=" + os + "&browser=" + browser + "&version=" + version + "&service=" + service + "&vm=" + which + "&width=" + width + "&height=" + height, "win", "tooltar=0,location=0,directories=0,status=0,menubar=0,scrollbars=0,resizable=1,width=" + width + ",height=" + height);
  } else {
    win = window.open("/vmware-rc/index." + ext + "?os=" + os + "&browser=" + browser + "&version=" + version + "&service=" + service + "&vm=" + which + "&width=" + width + "&height=" + height, "win", "tooltar=0,location=0,directories=0,status=0,menubar=0,scrollbars=0,resizable=1,width=" + width + ",height=" + height);
  }

  // Move the window to orgin for 
  // 1) consistency, and
  // 2) handling cases in which the window is too big for the screen.  Moving
  //    it to the origin makes it possible for the user to close the window.
  win.moveTo(0, 0);

  if(ctrlMenu && ctrlMenu.length)unCtrlMenu();
  aggressiveUpdate();
}

function citrix( which ) {
  return rc(which, "citrix", "html");
}

function msts( which ) {
  return rc(which, "msts", "html");
}

function vnc( which ) {
  getSysInfo();
  if(browser == "netscape" && !navigator.mimeTypes["application/vmvnc"]) {
    return vnc_mime();
  } else 
    return rc(which, "vnc", "vmvnc");
}

function vnc_mime() {
  alert("You need to configure VMware VNC Launcher");
  var win = window.open("/vmware/doc/en/vmvnc.html#netscape", "win", "tooltar=0,location=0,directories=0,status=0,menubar=0,scrollbars=1,resizable=1,width=" + width + ",height=" + height);
  //var win = window.open("/vmware-rc/index.html?os=" + os + "&browser=" + browser + "&version=" + version + "&service=vnc_mime", "win", "tooltar=0,location=0,directories=0,status=0,menubar=0,scrollbars=1,resizable=1,width=" + width + ",height=" + height);
}

function postOp( op, which, force ) {
  var f = window.document.operation;
  f.action=op;
  f.c.value=getCfg(which);
  f.f.value=force?1:0;
  f.submit();
}

function poweroff( which, force ) {
  var wid = 'vm' + which;
  var state = getState( which );
  
  if ( !executable( which ) ||
       (!isSoftable( which ) && !force) ||
       state == POWEROFF ||
       state == SUSPEND ||
       state == UNREACHABLE ||
       state == STUCK ||
       ( state == BUSY && !force ) )
    return;

  setState( which, BUSY );

  if (confirm( 'Powering a virtual machine off may adversely affect a running guest operating system.\nAre you sure you want to power off this virtual machine?' ) ) {
    showBusy(which, POWEROFF);
    // window.location.href='/poweroff?c=' + which + (force?'&f=1':'');
    if(hostOS == "MSWin32") {
      postOp('/poweroff/index.pl', which, force);
    } else {
       postOp('/poweroff', which, force);
    }
  } else { 
    setState( which, state  );
  }
}

function suspend( which, force ) {
  var wid = 'vm' + which;
  var state = getState( which );

  if ( state == SUSPEND ) {
    poweron( which );
    return;
  }

  if ( !executable( which ) ||
       state == POWEROFF ||
       state == UNREACHABLE ||
       state == STUCK ||
       state == BUSY )
    return;

  if (resumed(which) && repeatable(which)) {
    alert("Repeatable Resume is enabled for this virtual machine. " + 
      "The virtual machine has already been suspended once; " +
      "it cannot be suspended again until you disable Repeatable Resume " + 
      "on the virtual machine Details page.");
    return;
  }

  showBusy(which, SUSPEND);
  setState( which, BUSY );
  if(hostOS == "MSWin32") {
    postOp('/suspend/index.pl', which, force);
  } else {
    postOp('/suspend', which, force);
  }
}

function poweron( which, force ) {
  var wid = 'vm' + which;
  var state = getState( which );
  var op = state == SUSPEND ? 'resume' : 'poweron';
  
  if ( !executable( which ) ||
       state == POWERON ||
       state == UNREACHABLE ||
       state == STUCK ||
       state == BUSY )
    return;

  showBusy(which, POWERON);
  setState( which, BUSY );

  if(hostOS == "MSWin32") {
    postOp('/'+op+'/index.pl', which, force);
  } else {
    postOp('/'+op, which, force);
  } 
}

function resume( which, force ) {
  poweron( which, force );
}

function reset( which, force ) {
  var wid = 'vm' + which;
  var state = getState( which );
  
  if ( !executable( which ) ||
       (!isSoftable( which) && !force) ||
       state == POWEROFF ||
       state == SUSPEND ||
       state == UNREACHABLE ||
       state == STUCK ||
       (state == BUSY && !force) )
    return;

  setState( which, BUSY );

  if (confirm('Resetting a virtual machine may adversely affect a running guest operating system.\nAre you sure you want to reset this virtual machine?')) {
    showBusy(which, RESET);
    if(hostOS == "MSWin32") {
      postOp('/reset/index.pl', which, force);
    } else {
      postOp('/reset', which, force);
    }
  } else { 
    setState( which, state );
  }
}

function handleSubmit( ) {
  return false;
}

function getVmIndex( which ) {
  var f = window.document.form;
  if ( !f.vm )
    return -1;
  if ( f.vm[1] ) {
    for ( var i = 0; i < f.vm.length; i++ ) { 
      if ( which == f.vm[ i ].value )
        return i;
    }
  }
  if ( which == f.vm.value )
    return 0;
  return -1;
}

function getCfg( i ) {
  var f = window.document.form;
  if ( !f.vm ) 
    return '';
  if ( f.vm[1] )
    return f.vm[ i ].value;
  return f.vm.value;
}

function escapeJS(str) {
  bad='\'",.<>?/:;|\\[]{}=+-()*&%!~@#$^'.split('');
  for(var i=1;i<bad.length;i++){
    str=str.split(bad[i]);
    str=str.join(bad[i].charCodeAt(0));
  }
  return str;
}

function executable( i ) {
  var f = window.document.form;
  if ( !f.mode ) 
    return false;
  if ( f.mode[1] )
    return (parseInt(f.mode[ i ].value) & 1);
  return (parseInt(f.mode.value) & 1);
}

function resumed( i ) {
  var f = window.document.form;
  if ( !f.vmResumed ) 
    return false;
  if ( f.vmResumed[1] )
    return (f.vmResumed[i].value == "true");
  return (f.vmResumed.value == "true");
}

function repeatable( i ) {
  var f = window.document.form;
  if ( !f.vmResumeRepeatable ) 
    return false;
  if ( f.vmResumeRepeatable[1] )
    return (f.vmResumeRepeatable[i].value == "true");
  return (f.vmResumeRepeatable.value == "true");
}

var fmw;

function openFileManager() {
  fmw = window.open("/showdir", server_window_name("vmware_mui_file_manager"),
    "toolbar,resizable,scrollbars,status,width="+800+",height="+500);
}

function openHelp(ref,w,h) {
  window.open( ref,
               "vmware_mui_help",
               "location,menubar,resizable,scrollbars,status,toolbar,width="+w+",height="+h );
  aggressiveUpdate();
}

function update( ) { // strip auto-refresh from URL before reloading
  var arStr = "auto-refresh"
  if (window.location.href.indexOf(arStr+'=1')!=-1 &&
      window.location.search.length>1) {
    var loc = window.location.protocol + '//' + window.location.host +
      window.location.pathname;
    var s=window.location.search.substring(1);
    if (s.length>0) {
      var a=s.split("&");
      s='';
      for (var i=0; i<a.length; i++) {
        a[i]=a[i].split('=');
        if (a[i][0]!=arStr) {
          s+=(s.length>0?'&':'?')+a[i][0]+'='+a[i][1];
        }
      }
    }
    loc += s + window.location.hash;
    window.location.replace(loc);
  } else {
    window.location.reload();
  }
}

/* Use with non-navigating URL actions to ensure that the META http-equiv 
 * auto-refresh mechanism continues to function. Currently this applies to
 * console() and openHelp().
 */
function aggressiveUpdate() {
  window.setTimeout('window.location.reload( )', 1000 * 60);
}

var currentFilter;
var defaultFilter=new Array();
defaultFilter['avg_bandwidth']=1000;
defaultFilter['peak_bandwidth']=2000;
defaultFilter['burst_size']=160;

function storeFilter(){
  var f=document.form;
  currentFilter=new Array();
  currentFilter['avg_bandwidth']=f.avg_bandwidth.value;
  currentFilter['peak_bandwidth']=f.peak_bandwidth.value;
  currentFilter['burst_size']=f.burst_size.value;
  f.avg_bandwidth.value='';
  f.peak_bandwidth.value='';
  f.burst_size.value='';

}

function restoreFilter(){
  var f=document.form;
  var filter=currentFilter?currentFilter:defaultFilter;
  for(v in filter){
    f[v].value=filter[v];
  }
  f['avg_bandwidth'].focus();f['avg_bandwidth'].select();
  currentFilter=null;
}

var totalShares=new Array();
function storeShares(i,t){
  f=document.form;
  totalShares[t]=parseInt(f[t].value)-parseInt(f[i].value);
}

function sumShares(i,t){
  f=document.form;
  f[t].value=parseInt(f[i].value)+totalShares[t];
  storeShares(i,t);
}

function persistVmss(which,b) {
  var op = (hostOS == "MSWin32" ? "/set/index.pl?" : "/set?") +
    "Config.resume.repeatable=" + (b ? "true" : "false");
  postOp(op, which);
}

function server_window_name(s) {
  s += '_' + window.location.protocol.split(':').join('');
  s += '_' + window.location.hostname.split('.').join('_');
  s += window.location.port ? '_' + window.location.port : '';

  return escapeJS(s);
}

function logout() {
  if (fmw) { 
    if (!fmw.closed) fmw.close();
  } else {
    var s = document.all ? "left=0,top=0" : "screenX=0,screenY=0";
    s += ",width=100,height=100";
    fmw = window.open("/showdir", 
      server_window_name("vmware_mui_file_manager"), s);
    fmw.close();
  }
  if(hostOS == "MSWin32") {
    window.location.href = "/logout/index.pl";
  } else {
    window.location.href = "/logout";
  }
}
