<?xml version="1.0" encoding="iso-8859-1"?>
<!-- Todo:
  
[!DOCTYPE] Put common enitity declarations into a DTD. But DTDs don't seem
to be working correctly. Hmmm.

-->
<!DOCTYPE html [
<!ENTITY nbsp "<xsl:text disable-output-escaping='yes'>&amp;nbsp;</xsl:text>">
<!ENTITY ampersand "<xsl:text disable-output-escaping='yes'>&amp;</xsl:text>">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <!-- [ ! ] --><xsl:include href="common.xsl"/>
  <xsl:include href="../../js-import.xsl"/>
  <xsl:include href="pageHelp.xsl"/>


  <xsl:template match="/">
    <xsl:variable name="win32_suffix">
      <xsl:if test="/server/host@os = 'MSWin32'">/index.pl</xsl:if>
    </xsl:variable>
    <xsl:variable name="cfgName">
      <xsl:value-of select="/server/cfgName"/>
    </xsl:variable>
    <xsl:variable name="displayName">
      <xsl:value-of select="/server/displayName"/>
    </xsl:variable>
    <xsl:variable name="unrecoverableError">
      <xsl:choose>
        <xsl:when test="not(/server/timestamp) or /server/timestamp=0">1</xsl:when>
        <xsl:otherwise>0</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <HTML>
      <HEAD>
        <TITLE>
          <xsl:choose>
            <xsl:when test="$unrecoverableError=0">
              Confirm: Deleting "<xsl:value-of select="$displayName"/>"
            </xsl:when>
            <xsl:otherwise>Error</xsl:otherwise>
          </xsl:choose>
        </TITLE>
        <LINK rel="stylesheet" href="{$common}style.css" type="text/css" />

        <SCRIPT language="JavaScript">
          function DeleteVM() {
            document.frm.submit();
          }

          function adjust() {
          if (document.layers) return;
          var oh = document.all
            ? document.getElementById('bodyObj').scrollHeight
            : document.getElementById('bodyObj').offsetHeight;
          if (document.all) {
            window.resizeBy(0, oh - document.getElementById('bodyObj').clientHeight);
          } else {
            window.innerHeight = oh;
          }

          window.moveTo(32, 32);
          }
        </SCRIPT>
      </HEAD>

      <BODY id="bodyObj" bgcolor="#CCCCB3" link="#000000" vlink="#000000" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0" onload="adjust();">

        <TABLE width="100%" border="0" cellpadding="4" cellspacing="2">
          <FORM name="frm" method="GET" action="/deletevm{$win32_suffix}" onsubmit="return DeleteVM();">
            <INPUT type="hidden" name="request" value="delete"/>
            <INPUT type="hidden" name="c" value="{$cfgName}"/>
            <INPUT type="hidden" name="timestamp">
              <xsl:attribute name="value"><xsl:value-of select="/server/timestamp"/></xsl:attribute>
            </INPUT>

            <xsl:if test="/server/messages">
              <TR bgcolor="#FFFFE6">
                <TD valign="top">
                  <P>
                    <xsl:call-template name="error"/>
                  </P>
                </TD>
              </TR>
            </xsl:if>

            <xsl:if test="not(/server/messages)">
              <tr bgcolor="#E6E6CC">
                <td>
                  <p><small>
                    <b>Deleting "<xsl:value-of select="$displayName"/>"</b><br />
                    <small><xsl:value-of select="$cfgName"/></small>
                  </small>
                  </p>
                </td>
              </tr>

              <TR bgcolor="#FFFFE6">
                <TD>
                  <xsl:if test="/server/disks/disk[@usage='1']">
                    <p><small>
                      The following 
                      <xsl:choose>
                        <xsl:when test="/server/product@id='ESX'">VMFS</xsl:when>
                        <xsl:otherwise>virtual</xsl:otherwise>
                      </xsl:choose> disks are not in use at this time but will <em>not be deleted</em>
                      by default.  If you want to delete a disk, make the appropriate choice below:
                    </small></p>
                    <blockquote>
                      <TABLE width="480" border="0" cellpadding="0" cellspacing="0">
                        <TR>
                          <TD bgcolor="#999980">
                            <TABLE width="100%" border="0" cellpadding="2" cellspacing="1">
                              <TR bgcolor="#CCCCB3">
                                <TD width="1%" nowrap="1"><nobr><small>Delete</small></nobr></TD>
                                <TD width="1%" nowrap="1"><nobr><small>Save</small></nobr></TD>
                                <TD><small><xsl:choose><xsl:when test="/server/product@id='ESX'">VMFS</xsl:when><xsl:otherwise>Virtual</xsl:otherwise></xsl:choose> Disk</small></TD>
                              </TR>
                              <xsl:for-each select="/server/disks/disk[@usage='1']">
                                <xsl:variable name="diskName">
                                  <xsl:value-of select="./name"/>
                                </xsl:variable>

                                <TR bgcolor="#E6E6CC">
                                  <TD width="1%" nowrap="1" align="center">
                                    <INPUT type="radio" name="d_{$diskName}" value="del"/>
                                  </TD>
                                  <TD width="1%" nowrap="1" align="center">
                                    <INPUT type="radio" name="d_{$diskName}" value="save" checked="1"/>
                                  </TD>
                                  <TD>
                                    <small>
                                      <xsl:value-of select="$diskName"/>
                                    </small>
                                  </TD>
                                </TR>
                              </xsl:for-each>
                            </TABLE>
                          </TD>
                        </TR>
                      </TABLE>
                    </blockquote>
                  </xsl:if>

                  <!-- Do not show information about the disks that were not deleted.  Uncomment here to show.
                  <small><small>
                  The following <xsl:choose><xsl:when test="/server/product@id='ESX'">VMFS</xsl:when><xsl:otherwise>virtual</xsl:otherwise></xsl:choose> disks are also being used by other virtual machine and will NOT be deleted.
                  The virtual machines using this disk are listed after the disk name.
                  <ul>
                  <xsl:for-each select="/server/disks/disk">
                  <xsl:variable name="diskName">
                  <xsl:value-of select="./name"/>
                  </xsl:variable>

                  <xsl:variable name="usage">
                  <xsl:value-of select=".@usage"/>
                  </xsl:variable>

                  <xsl:if test="not($usage=1)">
                  <li><xsl:value-of select="$diskName"/></li>
                  <ul>
                  <xsl:for-each select="./vms/vm">
                  <xsl:variable name="diskUsageVM">
                  <xsl:value-of select="."/>
                  </xsl:variable>
                  <xsl:if test="not($cfgName=$diskUsageVM)">
                  <li><xsl:value-of select="$diskUsageVM"/></li>
                  </xsl:if>
                  </xsl:for-each>
                  </ul>
                  </xsl:if>
                  </xsl:for-each>
                  </ul>
                  </small></small>
                  -->
                  <xsl:if test="/server/files/file">
                    <p>
                      <small>The following files are only used by this virtual machine and will be deleted:</small>
                    </p>
                    <ul><small>
                      <xsl:for-each select="/server/files/file">
                        <li><xsl:value-of select="."/></li>
                      </xsl:for-each>
                    </small></ul>
                  </xsl:if>
                </TD>
              </TR>
            </xsl:if>
            <TR bgcolor="#E6E6CC">
              <TD align="right" colspan="3">
                <TABLE cellpadding="3" cellspacing="0">
                  <TR>
                    <xsl:if test="$unrecoverableError=0">
                      <TD>
                        <xsl:call-template name="button">
                          <xsl:with-param name="label">Delete Selected Files</xsl:with-param>
                          <xsl:with-param name="action">Javascript:DeleteVM()</xsl:with-param>
                          <xsl:with-param name="gutter-shadow">999980</xsl:with-param>
                          <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                          <xsl:with-param name="edge-shadow">999980</xsl:with-param>
                          <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                          <xsl:with-param name="base">CCCCB3</xsl:with-param>
                        </xsl:call-template>
                      </TD>
                    </xsl:if>

                    <TD>
                      <xsl:call-template name="button">
                        <xsl:with-param name="label"><xsl:choose>
                          <xsl:when test="$unrecoverableError=0">Cancel</xsl:when>
                          <xsl:otherwise>Close Window</xsl:otherwise>
                        </xsl:choose></xsl:with-param>
                        <xsl:with-param name="action">Javascript:self.close()</xsl:with-param>
                        <xsl:with-param name="gutter-shadow">999980</xsl:with-param>
                        <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                        <xsl:with-param name="edge-shadow">999980</xsl:with-param>
                        <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                        <xsl:with-param name="base">CCCCB3</xsl:with-param>
                      </xsl:call-template>
                    </TD>
                  </TR>
                </TABLE>
              </TD>
            </TR>
          </FORM>
        </TABLE>  
      </BODY>
    </HTML>
  </xsl:template>
</xsl:stylesheet>
