<?xml version="1.0" encoding="iso-8859-1"?>
<!-- Todo:
  
     [!DOCTYPE] Put common enitity declarations into a DTD. But DTDs don't seem
     to be working correctly. Hmmm.

  -->
<!DOCTYPE html [
<!ENTITY nbsp "<xsl:text disable-output-escaping='yes'>&amp;nbsp;</xsl:text>">
<!ENTITY ampersand "<xsl:text disable-output-escaping='yes'>&amp;</xsl:text>">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <!-- [ ! ] --><xsl:include href="common.xsl"/>
  <xsl:include href="../../js-import.xsl"/>
  <xsl:include href="pageHelp.xsl"/>


  <xsl:template match="/">
    <HTML>
      <HEAD>
        <TITLE>VMFS Browser</TITLE>
        <LINK rel="stylesheet" href="{$common}style.css" type="text/css" />
        <SCRIPT language="JavaScript">
          function CreateVMFS()
          {	
            diskID = getarg('id');
	    locationHref = '/vmfscreate?id='+diskID;
            var keys = new Array("extension", "permission", "defaultSize", "defaultName");
            for (var n in keys) {
               var key = keys[n];
               var val = getarg(key);
               if (val != null) {
                  locationHref += unescape('%26') + key + '=' + val;
               }
            }
            self.location.href = locationHref;
          }

          function FileClick(partition, filename, size)
          {
            opener.BrowseHandler(getarg('id'), partition, filename, size);
            self.close();
          }

        </SCRIPT>
        <SCRIPT src="/vmware/themes/default/ss/vmconfig.js"></SCRIPT>
      </HEAD>

      <BODY bgcolor="#FFFFFF" link="#000000" vlink="#000000" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">

         <TABLE width="100%" height="100%" border="0" cellpadding="1" cellspacing="0">
            <TR>
              <TD bgcolor="#66664D">
                <IMG src="{$imx}spacer.gif" width="6" height="6"/>
                <font color="#FFFFFF">
                  <xsl:choose>
                    <xsl:when test="/server/extension">
                      <small>VMFS Browser: Files with extension <xsl:value-of select="/server/extension"/></small>
                    </xsl:when>
                    <xsl:otherwise>
                      <small>VMFS Browser</small>
                    </xsl:otherwise>
                  </xsl:choose>
                </font>
              </TD>
            </TR>
            <TR>
              <TD bgcolor="#999980">
                <TABLE width="100%" height="100%"  border="0" cellpadding="0" cellspacing="0">
                  <TR bgcolor="#FFFFE6">
                    <TD valign="top">
                      <TABLE width="100%" height="100%" border="0" cellpadding="0" cellspacing="1">
                        <TR bgcolor="#CCCCB3">
                          <TD colspan="3">
                            <TABLE cellpadding="3"><TR><TD>  
                              <small><small>
                              Select a file from the following list.
                              </small></small>
                            </TD></TR></TABLE>	
                          </TD>
                        </TR>
                        <TR bgcolor="#CCCCB3">
                          <TD width="50%">
                            <TABLE cellpadding="1"><TR><TD>
                              <small><small>Name</small></small>
                            </TD></TR></TABLE>
                          </TD>
                          <TD>
                            <TABLE cellpadding="1"><TR><TD>
                              <small><small>Type</small></small>
                            </TD></TR></TABLE>
                          </TD>
                          <TD align="right"> 
                            <TABLE cellpadding="1"><TR><TD>
                              <small><small>Size</small></small>
                            </TD></TR></TABLE>
                          </TD>
                        </TR>
                    
                        <xsl:for-each select="/server/vmfs">
                          <xsl:variable name="partition">
                            <xsl:choose>
                              <xsl:when test="not(./logical_name = '')">
                                <xsl:value-of select="./logical_name"/>
                              </xsl:when>
                              <xsl:otherwise>
                                <xsl:value-of select="./partition"/>
                              </xsl:otherwise>
                            </xsl:choose>
                          </xsl:variable>
                          <TR>
                            <TD>
                              <nobr>
                              <small><small>
                                <img src="{$common.imx}scsi.gif" width="20" height="16" border="0" align="top"/>
                                <xsl:if test="not(./logical_name = '')"><xsl:value-of select="./logical_name"/> (</xsl:if><xsl:value-of select="./partition"/><xsl:if test="not(./logical_name = '')">)</xsl:if>
                              </small></small>
                              </nobr>
                            </TD>
                            <TD>
                              <nobr>
                              <small><small>
                                VMFS Partition
                              </small></small>
                              </nobr>
                            </TD>
                            <TD align="right">
                              <nobr>
                              <small><small>
                                <xsl:value-of select="./total_size"/>&nbsp;
                                <xsl:value-of select="./total_size@units"/>
                              </small></small>
                              </nobr>
                            </TD>
                          </TR>
                          <xsl:for-each select="./files/file">
                            <xsl:variable name="filename" select="string(name)"/>
                            <xsl:variable name="flen" select="string-length($filename)"/>
                            <xsl:variable name="size" select="string(size)"/>
                            <xsl:variable name="ext" select="string(/server/extension)"/>
                            <xsl:variable name="xlen" select="string-length($ext)"/>
                            <xsl:if test="not($ext) or $ext = substring($filename, $flen - $xlen + 1)">
                              <TR>
                                <TD>
                                  <nobr> 
                                  <small><small>
                                    <xsl:choose> 
                                      <xsl:when test="not(position()=last())">
                                        <img src="{$common.imx}tline.gif" width="20" height="15" border="0" align="top"/>
                                      </xsl:when>
                                      <xsl:otherwise>
                                        <img src="{$common.imx}cline.gif" width="20" height="15" border="0" align="top"/>
                                      </xsl:otherwise>
                                    </xsl:choose>
                                    <a href="Javascript:FileClick('{$partition}', '{$filename}', '{$size}')">
                                      <img src="{$common.imx}scsi.gif" width="20" height="15" border="0" align="top"/>
                                      <xsl:value-of select="./name"/>
                                    </a>
                                  </small></small>
                                  </nobr>
                                </TD> 
                                <TD>
                                  <nobr>
                                  <small><small>
                                    <xsl:choose>
                                      <xsl:when test="substring($filename, $flen - 3) = '.dsk'">
                                        Disk File
                                      </xsl:when>
                                      <xsl:when test="substring($filename, $flen - 4) = '.REDO'">
                                        Redo Log
                                      </xsl:when>
                                      <xsl:when test="substring($filename, $flen - 4) = '.vswp'">
                                        Swap File
                                      </xsl:when>
                                      <xsl:otherwise>
                                        File
                                      </xsl:otherwise>
                                    </xsl:choose>
                                  </small></small>
                                  </nobr>
                                </TD>
                                <TD align="right">
                                  <nobr>
                                  <small><small>
                                    <xsl:value-of select="./size"/>&nbsp;
                                    <xsl:value-of select="./size@units"/>
                                  </small></small>
                                  </nobr>
                                </TD>
                              </TR>
                            </xsl:if>
                          </xsl:for-each>
                        </xsl:for-each>
                        <TR>
                          <TD height="100%">&nbsp;</TD>
                        </TR>
                        <TR>
                          <TD colspan="3" valign="center" align="center"><small><small>
                          Or click
                          <a href="javascript:CreateVMFS()">here</a> 
                          to create a new file.
                          </small></small></TD>
                        </TR>
                        <TR bgcolor="#CCCCB3">
                          <TD align="right" colspan="3">
                            <TABLE cellpadding="1"><TR><TD>
               <xsl:call-template name="button">
                      <xsl:with-param name="label">Cancel</xsl:with-param>
                      <xsl:with-param name="action">Javascript:self.close()</xsl:with-param>
                      <xsl:with-param name="small">1</xsl:with-param>
                      <xsl:with-param name="gutter-shadow">999980</xsl:with-param>
                      <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                      <xsl:with-param name="edge-shadow">999980</xsl:with-param>
                      <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                      <xsl:with-param name="base">CCCCB3</xsl:with-param>
                    </xsl:call-template>
                            </TD></TR></TABLE>
                          </TD>
                        </TR>
                      </TABLE>  
                    </TD>
                  </TR>
                </TABLE>
              </TD>
            </TR> 
          </TABLE>
      </BODY>
    </HTML>
  </xsl:template>
</xsl:stylesheet>