<?xml version="1.0" encoding="iso-8859-1"?>
<!-- Todo:
  
     [!DOCTYPE] Put common enitity declarations into a DTD. But DTDs don't seem
     to be working correctly. Hmmm.

  -->
<!DOCTYPE html [
<!ENTITY nbsp "<xsl:text disable-output-escaping='yes'>&amp;nbsp;</xsl:text>">
<!ENTITY ampersand "<xsl:text disable-output-escaping='yes'>&amp;</xsl:text>">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <!-- [ ! ] --><xsl:include href="common.xsl"/>
  <xsl:include href="../../js-import.xsl"/>
  <xsl:include href="pageHelp.xsl"/>


  <xsl:template match="/">
    <HTML>
      <HEAD>
        <TITLE>Create VMFS File</TITLE>
        <LINK rel="stylesheet" href="{$common}style.css" type="text/css" />
        <SCRIPT language="JavaScript">
          function BrowseVMFS()
          {	
            diskID = getarg('id');
	    locationHref = '/vmfsbrowse?id='+diskID;
            var keys = new Array("extension", "permission", "defaultSize", "defaultName");
            for (var n in keys) {
               var key = keys[n];
               var val = getarg(key);
               if (val != null) {
                  locationHref += unescape('%26') + key + '=' + val;
               }
            }
            self.location.href = locationHref;
          }

          function FileClick()
          {
            opener.BrowseHandler(getarg('id'), 
                                 self.document.forms[0].scsiVolume[self.document.forms[0].scsiVolume.selectedIndex].value, 
                                 self.document.forms[0].scsiFileName.value, 
                                 self.document.forms[0].scsiSize.value);
            self.close();
          }

        </SCRIPT>
        <SCRIPT src="/vmware/themes/default/ss/vmconfig.js"></SCRIPT>
      </HEAD>

      <BODY bgcolor="#FFFFFF" link="#000000" vlink="#000000" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">

         <TABLE width="100%" height="100%" border="0" cellpadding="1" cellspacing="0">
            <TR>
              <TD bgcolor="#66664D">
                <IMG src="{$imx}spacer.gif" width="6" height="6"/>
                <font color="#FFFFFF">
                  <small>Create VMFS File</small>
                </font>
              </TD>
            </TR>
            <TR>
              <TD bgcolor="#999980">
                <TABLE width="100%" height="100%"  border="0" cellpadding="5" cellspacing="0" bgcolor="#FFFFE6">
                  <TR bgcolor="#FFFFE6">
                    <TD valign="top">

                     <FORM>               
                     <TABLE>
                      <TR>
                        <TD width="150">
                          <small><small>
                            Select a VMFS Volume:
                          </small></small>
                        </TD>
                        <TD>
                          <small><small><nobr>
                            <SELECT name="scsiVolume">
                              <xsl:for-each select="/server/vmfs">
                              <xsl:variable name="partition">
                                <xsl:choose>
                                  <xsl:when test="not(./logical_name = '')">
                                    <xsl:value-of select="./logical_name"/>
                                  </xsl:when>
                                  <xsl:otherwise>
                                    <xsl:value-of select="./partition"/>
                                  </xsl:otherwise>
                                </xsl:choose>
                              </xsl:variable>
                                <option value="{$partition}">
                                  <xsl:if test="not(./logical_name = '')"><xsl:value-of select="./logical_name"/> (</xsl:if><xsl:value-of select="./partition"/> --
                                  <xsl:value-of select="./free_size"/> MB Free<xsl:if test="not(./logical_name = '')">)</xsl:if>
                                </option>
                              </xsl:for-each>
                            </SELECT>
                          </nobr></small></small>
                        </TD>
                      </TR>
                      <TR>
                        <TD width="150">
                          <small><small>
                            Enter a unique name for this file.
                          </small></small>
                        </TD>
                        <TD>
                          <small><small><nobr>
                          <xsl:variable name="name">
                            <xsl:choose>
                              <xsl:when test="/server/defaultName"><xsl:value-of select="/server/defaultName" /></xsl:when>
                              <xsl:otherwise>Untitled</xsl:otherwise>
                            </xsl:choose>
                          </xsl:variable>
                            <xsl:variable name="ext" select="/server/extension"/>
                            <input name="scsiFileName" size="32" value="{$name}{$ext}"/>
                          </nobr></small></small>
                        </TD>
                      </TR>
                      <TR>
                        <TD width="150">
                          <small><small>
                            File Size:
                          </small></small>
                        </TD>
                        <TD>
                          <small><small><nobr>
                          <xsl:variable name="size">
                            <xsl:choose>
                              <xsl:when test="/server/defaultSize"><xsl:value-of select="/server/defaultSize" /></xsl:when>
                              <xsl:otherwise>4096</xsl:otherwise>
                            </xsl:choose>
                          </xsl:variable>
                          <input name="scsiSize" size="6" value="{$size}" /> MB
                          </nobr></small></small>
                        </TD>
                      </TR>
                    </TABLE>
                    </FORM>
                    </TD>
                  </TR>
                
                        <TR>
                          <TD height="100%">&nbsp;</TD>
                        </TR>
                        <TR>
                          <TD colspan="3" valign="center" align="center"><small><small>
                          Or click
                          <a href="javascript:BrowseVMFS()">here</a> 
                          to browse for an existing file.
                          </small></small></TD>
                        </TR>
                        <TR bgcolor="#CCCCB3">
                          <TD align="right" colspan="3">
                            <TABLE cellpadding="1"><TR>
                            <TD>
                    <xsl:call-template name="button">
                      <xsl:with-param name="label">Create</xsl:with-param>
                      <xsl:with-param name="action">Javascript:self.FileClick()</xsl:with-param>
                      <xsl:with-param name="small">1</xsl:with-param>
                      <xsl:with-param name="gutter-shadow">999980</xsl:with-param>
                      <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                      <xsl:with-param name="edge-shadow">999980</xsl:with-param>
                      <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                      <xsl:with-param name="base">CCCCB3</xsl:with-param>
                    </xsl:call-template>
                            </TD>
                            <TD>
                    <xsl:call-template name="button">
                      <xsl:with-param name="label">Cancel</xsl:with-param>
                      <xsl:with-param name="action">Javascript:self.close()</xsl:with-param>
                      <xsl:with-param name="small">1</xsl:with-param>
                      <xsl:with-param name="gutter-shadow">999980</xsl:with-param>
                      <xsl:with-param name="gutter-hilite">FFFFE6</xsl:with-param>
                      <xsl:with-param name="edge-shadow">999980</xsl:with-param>
                      <xsl:with-param name="edge-hilite">FFFFE6</xsl:with-param>
                      <xsl:with-param name="base">CCCCB3</xsl:with-param>
                    </xsl:call-template>
                            </TD>
                            </TR></TABLE>
                          </TD>
                        </TR>


                </TABLE>
              </TD>
            </TR> 
          </TABLE>
      </BODY>
    </HTML>
  </xsl:template>
</xsl:stylesheet>