# ---------------------------------------------------------------------------
# Copyright 1998 VMware, Inc.  All rights reserved. -- VMware Confidential
# ---------------------------------------------------------------------------

# File: VMware/IIS/Request.pm
# ---------------------------------------------------------------------------
#  Ports key functionality of Apache's request_rec 
# ---------------------------------------------------------------------------
use strict;
use CGI;


package VMware::IIS::Header;

my @h_out_k;
my @h_out_v;

sub new() {
   my ($class, @args) = @_;
   my $self = {};

   @h_out_k = ( );
   @h_out_v = ( );
      
   bless($self, $class);
   return($self);
}

sub add {
   my $self = shift;
   #my %h = shift;
   my $k = shift;
   my $v = shift;
   
   #my $key;
   #foreach $key (keys %h) {
   #   print "** headers_out->add $key " . $h{$key} . "\n";
   #   push(@h_out_k, $key);
   #   push(@h_out_v, $h{$key});
   #}

   push(@h_out_k, $k);
   push(@h_out_v, $v);   
   
   return;
}

package VMware::IIS::Request;
use VMware::Control::Profiler;

my %headers;
my $headers_out;
my $p = VMware::Control::Profiler::getInstance("mui");

sub new() {
   my ($class, @args) = @_;
   my $self = {};

   %headers = { };
   $headers_out = VMware::IIS::Header->new();

   bless($self, $class);
   return($self);
}

sub uri {
   my $self = shift;

   return;
}

sub method($) {
   return $ENV{REQUEST_METHOD};	
}

sub content_type {
   my $self = shift;
   my $type = shift;
   $headers{"Content-Type"} = $type;
}   


sub header_out(){
   my $self = shift;
   my $k = shift;
   my $v = shift;
   
   $headers{$k} = $v;
}

sub headers_out(){
   my $self = shift;

   return $headers_out;   
}

sub get_http_header {
   my $stub = $p->profile();
   my $self = shift;
   my $key;
   my $i;
   my $out = "";
   
   for ($i=0; $i <= $#h_out_k; $i++) {
      $out = $out . $h_out_k[$i] . ": " . $h_out_v[$i] . "\n";
   }
      
   for $key (keys %headers) {
      if(defined($headers{$key})) {
         $out = $out . "$key" . ": " . $headers{$key} . "\n";
      }
   }

   $out = $out . "\n";
   return $out;
}

sub send_http_header {
   print get_http_header();
}

sub print($) {
   my $self = shift;
   my $s = shift;
   
   print $s;
}
   
sub args {
   my $stub = $p->profile();
   my $self = shift;

   my $q = new CGI;
   my @keys = $q->param;
   my $key;
   
   my %params;
   
   my $i;
   
   for ($i=0; $i < $#keys + 1; $i++) {
      $params{$keys[$i]} = URI::Escape::uri_unescape($q->param($keys[$i]));
   }

   return %params;
}

1;
