#!/usr/bin/perl -w

#############################################################
# Copyright 1998 VMware, Inc.  All rights reserved. -- VMware Confidential
#############################################################
#
# GSXServerConfig.pm
# 
# A script that presents the setup options available.
package VMware::Management::GSXServerConfig;

use strict;
use VMware::ExtHelpers qw(&Warning 
                          $gPanicCallback 
			  &clearWarnings);
use CGI;
use VMware::Management::ConfigHTML;

my $htmlTitle = "VMware GSX Server Configuration";
my $user;
    
my @htmlPath = ( );

sub handleRequest($) {
    my ($cgi) = @_;
    my $s = "";
    my $url_self = $cgi->url(-relative=>1);

    # XXX Hack
    $gPanicCallback = \&VMware::Management::ConfigHTML::PanicCallbackHTML;


	$s = &VMware::Management::ConfigHTML::toHTMLPath(\@htmlPath, $htmlTitle);
	$s .= <<END_HTML;
<hr>
<h3> VMware GSX Server Configuration </h3>
<dl>
  <dt class="txt">
  <a href="/securityconfig">Security Settings</a>
  </dt>
  <dd class="txt">
  Configure GSX Server security properties.  In this step you can
  set up SSL-encrypted access to the server.
  </dd>
</dl>
<hr>
END_HTML

	return ($s);
}



sub handler {
    # Delete the PATH to get by the tainted security requirements of Perl
    delete($ENV{'PATH'}); 

    umask 022;   # Create files that are not writable by group
    
    &clearWarnings();

	my $s;
    my $cgi = new CGI( shift( ) );
    my %MimeHeaders = ( "Content-Type"  => "text/html; charset=iso-8859-1",
			"Pragma"        => "no-cache",
			"Cache-Control" => "no-cache",
			);

	my $s = &VMware::Management::ConfigHTML::toHTMLHeader($htmlTitle, $user);

    if (!&VMware::Management::ConfigHTML::isAdminUser()) {
	   my $url_self = $cgi->url(-relative=>1);
	   $s .= &VMware::Management::ConfigHTML::toErrorHTML("Operation Not Permitted",
			   "<p class=\"txt\">You must have administrative privileges to perform " .
			   "this operation.  </p>",
			   $htmlTitle);
	} else {
       $s .= handleRequest($cgi);
	}
    
	$s .= &VMware::Management::ConfigHTML::toHTMLFooter();
    return ( $s, %MimeHeaders );
}

1;
