# ---------------------------------------------------------------------------
# Copyright 1998 VMware, Inc.  All rights reserved. -- VMware Confidential
# ---------------------------------------------------------------------------
package VMware::Management::Logout;
# File: VMware/Management/Logout.pm

use strict;

use VMware::Control '1.00';
use VMware::Control::Server ();
use VMware::Control::Profiler;
use VMware::Management::Util qw( trace
                                 string_to_file
                                 file_to_string
				 hash_cookies
                                 connect_ctrl_obj
                                 append_error );

use CGI;

my $p = VMware::Control::Profiler::getInstance("mui");

sub handler {
    my $stub = $p->profile();
  my $q = new CGI( shift( ) );
  my $url = $ENV{ "vmware_LOGIN_URI" };

  if ( $q->param("n") ) {
      $url = $q->param( "n" );
  }
  trace( "handler( ) called.", "debug" );
  my $expire_now = VMware::Management::Util::rfc_1123_time( time( ) - (60 * 60 * 24) );

  my %cookies = hash_cookies();
  if ($^O ne "MSWin32") {
    VMware::Management::Session::delete_session( $cookies{"vmware.mui.sid"} );
  }

  if ( $^O eq "MSWin32" ) {
     return ( qq(<head><META HTTP-EQUIV="Refresh" Content=0;URL="$url"></head>),
           "kid-Cookie" => "vmware.mui.kid=;EXPIRES=$expire_now;path=/;",
           "sid-Cookie" => "vmware.mui.sid=;EXPIRES=$expire_now;path=/;" );
  } else {
     return ( "",
           "Location" => $url,
           "kid-Cookie" => "vmware.mui.kid=;EXPIRES=$expire_now;path=/;",
           "sid-Cookie" => "vmware.mui.sid=;EXPIRES=$expire_now;path=/;" );
  }

}

1;
