# ---------------------------------------------------------------------------
# Copyright 1998 VMware, Inc.  All rights reserved. -- VMware Confidential
# ---------------------------------------------------------------------------
package VMware::Management::NewVM;

use strict;

use VMware::Control '1.00';
use VMware::Control::Server ();
use VMware::Control::Profiler;
use VMware::Management::Util ();

use CGI ();

my $p = VMware::Control::Profiler::getInstance("mui");

sub handler {

   my $stub = $p->profile();
   my $url;

   my $server = &VMware::Control::Server::new();
   my ($server_ok, $err, $errstr) = &VMware::Management::Util::connect_ctrl_obj($server);
   my $productName = &VMware::Management::Util::getProductName($server);

   if ($productName eq "ESX") {
      $url = "/vmcfg-esx";
   } elsif ($productName eq "GSX") {
      $url = "/vmcfg-gsx";
   } else {
      $url = "/overview";   # Cannot determine, so just send them to the OV page
   }


   if ( $^O eq "MSWin32" ) {
      $url .= "/index.pl";
   }

   if($ENV{'QUERY_STRING'} ne "") {
      $url .= "?$ENV{QUERY_STRING}";
   }

   return ( "&nbsp",
            "Location"  => $url);
}

1;
