# ---------------------------------------------------------------------------
# Copyright 1998 VMware, Inc.  All rights reserved. -- VMware Confidential
# ---------------------------------------------------------------------------
package VMware::Management::SxLogout;
# File: VMware/Management/SxLogout.pm

use strict;

use VMware::Control '1.00';
use VMware::Control::Server ();
use VMware::Control::Profiler;
use VMware::Management::Util qw( trace
				 hash_cookies
                                 connect_ctrl_obj );

use CGI;

my $p = VMware::Control::Profiler::getInstance("mui");

sub handler {
   VMware::Management::Util::trace("SxLogout::handler() [", "debug");
   
   my $stub = $p->profile();
   my $q = new CGI(shift());

   my $expire_now = VMware::Management::Util::rfc_1123_time(time() - (60*60*24));

   my %cookies = hash_cookies();
   if ($^O ne "MSWin32") {
      VMware::Management::Util::trace("Deleting session...", "debug");
      VMware::Management::Session::delete_session($cookies{"vmware.mui.sid"});
   }

   my $head = qq[<html><head><title>Logout: VMware Management Interface</title><script>$/];
   my $tail = qq[</script></head><body bgcolor="#336699" onload="try{if(parent.logoutCb)parent.logoutCb(self);}catch(e){;}"></body></html>$/];
   
   VMware::Management::Util::trace("] SxLogout::handler()", "debug");
   
   return ("${head}${tail}",
	   "Pragma"        => "no-cache",
	   "Cache-Control" => "no-cache",
	   "kid-Cookie"    => "vmware.mui.kid=;EXPIRES=$expire_now;path=/;",
	   "sid-Cookie"    => "vmware.mui.sid=;EXPIRES=$expire_now;path=/;",
	   "Content-Type"  => "text/html; charset=utf-8");
}

1;
